/***************************************************************************
                          ADM_audiodevice.cpp  -  description
                             -------------------
    begin                : Sat Sep 28 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "config.h"
#ifdef USE_ARTS
#include <artsc.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>


#include "avi_vars.h"

#include "audio_out.h"

#include "ADM_audiodevice/ADM_deviceoss.h"
#ifdef USE_ARTS
#include "ADM_audiodevice/ADM_deviceArts.h"

#endif
#include "gui_action.hxx"

audioDevice *device=NULL;
void ADM_audioInit(void )
{
	
#ifdef OSS_SUPPORT
		device=new ossAudioDevice();
	//	device=new artsAudioDevice();
#else
		device = new dummyAudioDevice();
#endif	
}

void ADM_switch(Action action)
{
	if(device) 
	       {
				delete device;
			}
	device=NULL;
	
	switch(action)
	{
#ifdef OSS_SUPPORT
		  case  ACT_SelectDevOSS :
								device=new 	 ossAudioDevice;
								break; 
#endif
#ifdef USE_ARTS
		case ACT_SelectDevArts:
							device=new 	 artsAudioDevice;
								break; 

#endif
				 case  ACT_SelectDevDummy:
					default:
								device=new 	 dummyAudioDevice;
								break; 

	}	
	
}

//_______________________________________________
//
//
//_______________________________________________
void AVDM_AudioClose(void) 
{
	device->stop();
}

//_______________________________________________
//
//
//_______________________________________________
uint32_t AVDM_AudioSetup(uint32_t fq, uint32_t channel) 
{
	if(channel>2) channel=2;
	return device->init(channel,fq);
}

//_______________________________________________
//
//
//_______________________________________________
uint8_t AVDM_AudioPlay(uint8_t * ptr, uint32_t nb) 
{
	return device->play(nb,ptr);
}

