/***************************************************************************
                          filter.cpp  -  description
                             -------------------
    begin                : Wed Mar 27 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <assert.h>


#include "fourcc.h"
#include "avio.hxx"
#include "config.h"
#include "ADM_toolkit/toolkit.hxx"
#include "ADM_editor/ADM_edit.hxx"
#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_filter/video_filters.h"
#include "ADM_video/ADM_vidPartial.h"
#include "avi_vars.h"
//
		
// exported vars
uint32_t nb_video_filter=0;		
uint32_t nb_active_filter=0;
FILTER_ENTRY allfilters[MAX_FILTER];
FILTER  videofilters[MAX_FILTER];

extern ADM_Composer *video_body;
//

// dummy constructor used to register the filter
//____________________________________
AVDMVideo_FilterDec::AVDMVideo_FilterDec(char *name,
									AVDMGenericVideoStream *(*create) (AVDMGenericVideoStream *in, void *))
{
    UNUSED_ARG(name);
    UNUSED_ARG(create);
         //registerFilter(name, create);
	 //
}
//
// Delete everything that is pending
void filterCleanUp( void )
{
	for(uint32_t i=0;i<nb_active_filter;i++)
	{
		  	delete videofilters[i].filter;
#warning Memory leak
            //if(videofilters[i].conf)  		
	          //delete videofilters[i].conf;  		
             videofilters[i].conf=NULL;  		
             videofilters[i].filter=NULL;  		
	}
   nb_active_filter=0;
}
void registerFilter(const char *name,VF_FILTERS tag,uint8_t viewable,
		AVDMGenericVideoStream *(*create) (AVDMGenericVideoStream *in, void *))
{
        assert(nb_video_filter<(MAX_FILTER-1));
        allfilters[ nb_video_filter].name=name;
        allfilters[ nb_video_filter].create=create;
        allfilters[ nb_video_filter].tag=tag;
        allfilters[ nb_video_filter].viewable=viewable;
        nb_video_filter ++; 
        if(viewable==1)
        printf("\n Registred filter %lu: %s",nb_video_filter,name);

}		

AVDMGenericVideoStream *getLastVideoFilter( void)
{
extern ADM_Composer *video_body;
  // sanity check
  	if(nb_active_filter==0)
  		{
  		 		nb_active_filter=1;
  		 		videofilters[0].filter=  new AVDMVideoStreamNull(video_body);  		
  		 		videofilters[0].name=  "Null";  		  		 		  		 		
  		}
       return videofilters[  nb_active_filter-1].filter;
}
AVDMGenericVideoStream *getFirstVideoFilter( void)
{
extern ADM_Composer *video_body;
  // sanity check
  	if(nb_active_filter==0)
  		{
  		 		nb_active_filter=1;
  		 		videofilters[0].filter=  new AVDMVideoStreamNull(video_body);  		
  		 		videofilters[0].name=  "Null";  		  		 		  		 		
  		}
       return videofilters[  0].filter;
}


//
//	Parse the list of active filters, delete them et recreate them with (new ?) configuration
//
void updateVideoFilters(void )
{
 	
  		 		videofilters[0].filter=  new AVDMVideoStreamNull(video_body);  		
  		 		videofilters[0].name=  "Null";  		  		 		  		 		
  		if(nb_active_filter<=1)
  		{
  		 	nb_active_filter=1;
  		 	return;
  		}
  		// Rebuild other filters
  		    for(uint32_t i=1;i<nb_active_filter;i++)
						{
                   		VF_FILTERS tag;
                    		AVDMGenericVideoStream *old;
                   			old= videofilters[i].filter;
                  			tag=videofilters[i].tag;
                      
                      	videofilters[i].filter=filterCreateFromTag(tag,
                            			(uint8_t *)videofilters[i].conf,
                               		videofilters[i-1].filter);												                                                 
                                           	
                          //	 		videofilters[i-1].conf=NULL;						
                        	delete old;
            	}
	
}
//
//	Create a filter from : its tag, its config and an input stream
//
AVDMGenericVideoStream *filterCreateFromTag(VF_FILTERS tag,uint8_t *conf, AVDMGenericVideoStream *in) 
{
	 AVDMGenericVideoStream *filter;

			assert(tag!=VF_INVALID);
			for(unsigned int i=0;i<nb_video_filter;i++) 
				{
					if(tag==allfilters[i].tag) 
						{
	 						filter=allfilters[i].create( in, conf);
							return filter;
						}
				}
			assert(0);
			return NULL;                      
}
/*____________________________________
	Save and load current set of filters
	
	We save/load the tag that identifies the filter
	and a raw hex dump of its config
		+ comment and name in clear text
	____________________________________ 
*/
void filterSave(char *name,uint8_t silent)
{
FILE *out;
uint32_t tag;
uint16_t size;
uint8_t *dump;
	
	
	if(2>nb_active_filter)
		{
			if(!silent)
			 	GUI_Alert("Nothing to save");
			  return;
			}
	out=fopen(name,"wt");
	if(!out)
		{
			 	GUI_Alert("Error writing filters file");
			  return;
			}			
	for(uint32_t i=1;i<nb_active_filter;i++)
			{
				 tag=videofilters[i].tag;
				 fprintf(out,"#%s\n", allfilters[ tag].name);
				 fprintf(out,"#%s\n", videofilters[i].filter->printConf());
 				 fprintf(out,"Tag:%ld\n", tag);
       
				 dump= videofilters[i].filter->getBinaryConf( &size);
			   fprintf(out,"%04X \n",size);
			   
				 if(size)
				 		{
  			   			
	
						  	for(uint32_t j=0;j<size;j++)
						   			fprintf(out,"%02X ",*dump++);
						    fprintf(out,"\n");
						 }
					else
						{
							 	assert(dump==NULL);
							}
							
			}			
			fclose(out);
	
}
// ugly..
static inline int hex(int i)
{
		if(i>'A')
				{
					 	i=i-'A'+10;
					}
		else
				i=i-'0';
		return i;
		
}
/*

  	Try to rebuild filter from text file


*/
 void filterLoad(char *name)
 {
 	filterLoad(name,0);
 }
 void filterSave(char *name)
 {
 	filterSave(name,0);
 }
 
 void filterLoad(char *name,uint8_t silent)
 {
	 
FILE *out; // in fact it is on
VF_FILTERS tag;
uint32_t size;                 
uint8_t  string[500];

	out=fopen(name,"rt");
	if(!out)
		{
			if(!silent)
			 	GUI_Alert("Error reading filter file");
			  return;
			}

	printf("\n Loading filters from :%s\n",name);
			
	if(1<nb_active_filter)
		{
					  filterCleanUp();
			}
			
	// if there is no active filter 
	// Create at least the editor output one		
			
	if(!nb_active_filter)
		{
  		 		videofilters[0].filter=  new AVDMVideoStreamNull(video_body);  		
  		 		videofilters[0].name=  "Null";  		  		 		  		 		
    }
			
	nb_active_filter=1;
			
  // while there is something interesting			
	while(fgets((char *)string,400,out))
	{
		if(string[0]!='#') 
		{
				tag=VF_INVALID;
				size=0;

				sscanf((char *)string,"Tag:%u", (unsigned int *)&tag);
			//	printf("\n --> %s -->",string);
				assert(fgets((char *)string,400,out));
				
				sscanf((char *)string,"%04lX", &size);
			//	printf("\n --> %s -->",string);

				
				// we got tag and size, now build setup
      //  printf("\n tag : %d size : %d",tag,size);
								
				uint8_t *c=NULL;
				uint8_t *setup=NULL;
				int hex0,hex1;
			
				if(size)
				{
					assert(fgets((char *)string,400,out));
					c=string;
					setup=(uint8_t *)malloc(size);
					assert(setup);
				
      	  for(uint32_t j=0;j<size;j++)
        	{
						hex0=hex((int)*c++);
						hex1=hex((int)*c++);c++; // skip blank
					
						setup[j]=(hex0<<4)+hex1 ;
					}
				}
				else
				{
					setup=NULL;	
				}				
					// now create filter
				videofilters[nb_active_filter].filter= filterCreateFromTag( tag,
																					(uint8_t *)setup,
																					videofilters[nb_active_filter-1].filter);																									
				videofilters[nb_active_filter].tag=tag;			
				videofilters[nb_active_filter].conf=setup;			
				nb_active_filter++;
			}					
			else
				{
				//	 	printf("\n comment : %s",string);
					}
							
		}			
		fclose(out);

	 
	 }
/*---------------------------------------*/	 
static   AVDMGenericVideoStream *preview;
void 	editorReignitPreview( void )
{
 	
            preview=getLastVideoFilter();
            GUI_PreviewEnd();
            GUI_PreviewInit(preview->getInfo()->width,
									preview->getInfo()->height);

}

void editorKillPreview( void )
{
      GUI_PreviewEnd();
      preview=NULL;
}

static uint8_t unpackd[MAXIMUM_SIZE*MAXIMUM_SIZE*3];


void editorUpdatePreview(uint32_t framenum)
{
//
//
//
	uint32_t fl,len;	
 	assert(preview);

  if( GUI_StillAlive())
  {
		preview->getFrameNumberNoAlloc(framenum,&len,unpackd,&fl);
		GUI_PreviewUpdate(unpackd);
  }

//   virtual uint8_t getFrameNumberNoAlloc(uint32_t frame, uint32_t *len,
//          																				uint8_t *data,uint32_t *flags)=0;

}
