/***************************************************************************
                          vidVCD.cpp  -  description
                             -------------------
    begin                : Wed Aug 21 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr

	This is a meta filter that adds the needed filter to convert the stream to VCD resolution
   It computes the parmater and create
			- A resize filter
			- A Add border filter

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <assert.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <math.h>

#include "fourcc.h"
#include "avio.hxx"
#include "avi_vars.h"
#include "config.h"
#include "ADM_toolkit/toolkit.hxx"
#include "prototype.h"
#include "ADM_editor/ADM_edit.hxx"
#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_filter/video_filters.h"


extern AVDMGenericVideoStream *addBorder_create(AVDMGenericVideoStream *in, void *param);

//___________________________________________
extern FILTER_ENTRY allfilters[MAX_FILTER];
extern uint32_t nb_video_filter;
extern FILTER videofilters[MAX_FILTER];
extern uint32_t nb_active_filter;
extern ADM_Composer *video_body;
static uint8_t computeResize( 

uint32_t targetx,
uint32_t targetxFinal,
uint32_t targetyPAL,
uint32_t targetyNTSC

);

void setSVCD( void );
void setVCD( void );
void setDVD( void );

 void setVCD( void )
{
 	if(! computeResize( 

	352,
	352,
	288,
	240

)  ) GUI_Alert("cannot find PAL/NTSC type !");



}

 

 void setSVCD( void )
{
 	
	if(! computeResize( 
  480,
	720,
	576,
	480
)  ) GUI_Alert("cannot find PAL/NSTC type !");

}



 void setDVD( void )
{
 	 if(! computeResize( 

	720,
	720,
	576,
	480
)  ) GUI_Alert("cannot find PAL/NSTC type !");

}

//
//  Compute the filters, aspect is the reduction factor for h
//  =1 for VCD/DVD
//	=2/3 for SVCD
//------------------------------
uint8_t computeResize( 
	uint32_t targetx,
	uint32_t targetxFinal,	
	uint32_t targetyPAL,
	uint32_t targetyNTSC
   )
{
 	
ADV_Info 				*info;
uint8_t res=0; /* 1 Pal, 2 NSTC or film */
uint32_t targety;
			info=getLastVideoFilter()->getInfo( );		

		// search framerate to get resolution

#define CHECK(x,y) if ( (info->fps1000-x)*(info->fps1000-x) < 10000) res=y;

		CHECK(23976,2);
		CHECK(30000,2);
		CHECK(25000,1);

		if(!res)
					{
                   	
						return 0;
					}
    if(res==2) targety=targetyNTSC;
    	else		targety=targetyPAL;
		

		double rx, ry;
		uint32_t newx, newy;
		uint32_t cropx, cropy;

	

			rx=info->width;
			rx=rx/targetxFinal;
			
			
			ry=info->height;
			ry=ry/targety;

			// which do do we compress less ?
			if(rx>ry) // resize by X, add border afterward
					{
     							newx=targetx;
							ry=info->height;
							ry=ry/rx;
							newy=(uint32_t)floor(ry+0.49);	
							printf(" resize by x\n");												
					}
			else
					{
							newy=targety;
							rx=info->width;
							rx=rx/ry;
							rx*=targetx;
							rx/=targetxFinal;							
							newx=(uint32_t)floor(rx+0.49);													
							printf(" resize by y\n");												
							
					}

					printf("\n New X x Y = %lu x %lu\n",newx,newy);

					// correct odd / even

					newx-=newx%4;
					newy-=newy%4;

					// Now correct crop
				
			
					cropx=targetx-newx;
					cropy=targety-newy;

					printf("\n Resized to : %lu x %lu, add black border %lu x %lu",
													newx,newy,cropx,cropy);

					// now build filter
				
						// first resize

						RESIZE_PARAMS *rresize;
	
						rresize=new (RESIZE_PARAMS);
						rresize->w=newx;
						rresize->h=newy;
						rresize->algo=1;

						
  		 				videofilters[nb_active_filter].filter=  new AVDMVideoStreamResize(getLastVideoFilter(),(void *)rresize);  		
  		 				videofilters[nb_active_filter].name=  "Resize *VCD";  	
			         		videofilters[nb_active_filter].tag = VF_RESIZE;
						nb_active_filter++;

						// then add crop
				       CROP_PARAMS *ccrop;

						ccrop=new  CROP_PARAMS;

						ccrop->cropx=ccrop->cropx2=cropx>>1;
						ccrop->cropy=ccrop->cropy2=cropy>>1;

  		 				videofilters[nb_active_filter].filter= addBorder_create(videofilters[nb_active_filter-1].filter,(void *)ccrop);  				
  		 				videofilters[nb_active_filter].name=  "AddBorder *VCD";  					
   					  	videofilters[nb_active_filter].tag = VF_ADDBORDER;
						nb_active_filter++;

                        return 1;
}

