/***************************************************************************
                          GUI_Tshift.cpp  -  description
                             -------------------
    begin                : Sat Apr 13 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "avi_vars.h"


static void on_tsiCallBack(GtkButton * button, gpointer user_data);
static void on_tsi_callback_ko(GtkButton * button, gpointer user_data);

static int tsilock;
static GtkWidget *entry2;
//________________________________
int getdelayparameter(int *delay)
{
    static GtkWidget *wdg;
    int d,ret;
    char *str;
    char string[200];

    wdg = create_Time_Shift("TimeShift", "Timeshift(ms)");
    tsilock = 0;
    	sprintf(string, "%d", (int) *delay );
					gtk_editable_insert_text(GTK_EDITABLE(entry2),
					 string, strlen(string), &ret);

    gtk_widget_show(wdg);

    while (!tsilock)
      {
	  gtk_main_iteration();
      }
    if (tsilock == 1)
      {
	  // retrieve value
	  // now we got the menu item selected
	  str = gtk_editable_get_chars(GTK_EDITABLE(entry2), 0, -1);
	  d = atoi(str);
	  *delay = d;
	  gtk_widget_destroy(wdg);
	  return 1;
      }
    return 0;
}


void on_tsi_callback_ko(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    UNUSED_ARG(user_data);
    on_tsiCallBack(NULL, (gpointer) 0);

}

void on_tsiCallBack(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    int res;

    res = (int) user_data;
    if (tsilock)
	return;			// second call back->ignore.
    switch (res)
      {
      case 1:
	  tsilock = 1;
	  //gtk_hide_widget(wdg);

	  break;
      case 0:
	  tsilock = -1;
	  break;
      }
    return;

};




//________________________________
int getFramenum(unsigned long int *fn)
{
    static GtkWidget *wfn;
    long int l;
    char *str;

    wfn = create_Time_Shift("Frame number", "Enter frame#:");
    tsilock = 0;
    gtk_widget_show(wfn);

    while (!tsilock)
      {
	  gtk_main_iteration();
      }
    if (tsilock == 1)
      {
	  // retrieve value
	  // now we got the menu item selected
	  str = gtk_editable_get_chars(GTK_EDITABLE(entry2), 0, -1);
	  l = atoi(str);
	  *fn = l;
	  gtk_widget_destroy(wfn);
	  return 1;
      }
    return 0;
}


GtkWidget *create_Time_Shift(const char *nm, const char *lb)
{
    GtkWidget *Time_Shift;
    GtkWidget *vbox7;
    GtkWidget *label15;
//  GtkWidget *entry2;
    GtkWidget *button_ts_ok;

    Time_Shift = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    // gtk_object_set_data (GTK_OBJECT (Time_Shift), "Time_Shift", Time_Shift);
    gtk_object_set_data_full(GTK_OBJECT(Time_Shift),
			     nm,
			     Time_Shift,
			     (GtkDestroyNotify) on_tsi_callback_ko);
    gtk_widget_set_usize(Time_Shift, 120, 70);
    gtk_window_set_title(GTK_WINDOW(Time_Shift), nm);
    gtk_window_set_modal(GTK_WINDOW(Time_Shift), 1);
    vbox7 = gtk_vbox_new(FALSE, 0);
    gtk_widget_ref(vbox7);
    gtk_object_set_data_full(GTK_OBJECT(Time_Shift), "vbox7", vbox7,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(vbox7);
    gtk_container_add(GTK_CONTAINER(Time_Shift), vbox7);

    label15 = gtk_label_new(lb);
    gtk_widget_ref(label15);
    gtk_object_set_data_full(GTK_OBJECT(Time_Shift), "label15", label15,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(label15);
    gtk_box_pack_start(GTK_BOX(vbox7), label15, FALSE, FALSE, 0);

    entry2 = gtk_entry_new();
    gtk_widget_ref(entry2);
    gtk_object_set_data_full(GTK_OBJECT(Time_Shift), "entry2", entry2,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(entry2);
    gtk_box_pack_start(GTK_BOX(vbox7), entry2, FALSE, FALSE, 0);

    button_ts_ok = gtk_button_new_with_label("OK");
    gtk_widget_ref(button_ts_ok);
    gtk_object_set_data_full(GTK_OBJECT(Time_Shift), "button_ts_ok",
			     button_ts_ok,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(button_ts_ok);
    gtk_box_pack_start(GTK_BOX(vbox7), button_ts_ok, FALSE, FALSE, 0);

    gtk_signal_connect(GTK_OBJECT(button_ts_ok), "clicked",
		       GTK_SIGNAL_FUNC(on_tsiCallBack), (void *) 1);
    return Time_Shift;
}
