/***************************************************************************
                          GUI_Working.cpp  -  description
                             -------------------
    begin                : Sat Apr 13 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <math.h>
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "avi_vars.h"
#include "ADM_toolkit/toolkit.hxx"

extern uint32_t getTime(int called);
static void on_work_destroy(GtkObject * object, gpointer user_data);
static GtkWidget *working;

static   GtkWidget *label_timeleft;
static   GtkWidget *progressbar1;

static int abort_flag;
static uint32_t starttime;
static int lastper;


void GUI_Working(void)
{
    abort_flag = 0;
    lastper = 0;
    starttime = getTime(0);
    if(working)
    {
    				GUI_Alert("Internal problems with GUI_working");
    }
    printf("\n *** working ***\n");
    while (gtk_events_pending())
      {
	  gtk_main_iteration();
      }
    working=create_working();
    gtk_widget_show(working);
    while (gtk_events_pending())
      {
	  gtk_main_iteration();
      }
}
void GUI_StopWorking(void)
{
		if(!working)
		{
			
				GUI_Alert("internal problem with GUI_working");
		}
    if (working)
					gtk_widget_destroy(working);
    working = (GtkWidget *) NULL;
}
int GUI_UpdateWorking(int n)
{
    char b[100];
    uint32_t secdone, sectogo;
    // try to update time
    if(!working) return 1;
    if (n == 0)
      {
	  sectogo = 999;
    } else
      {

	  double d;
	  secdone = getTime(1) - starttime;;
	  // now expand the remaining time
	  // sectdone/sectotal=n/100
	  // sectotal=100*secdone/n
	  d = secdone;
	  d /= n;
	  d *= 100.;		// 100* for %, /1000 for ms -> /10
	  d -= secdone;
     // d is in ms, divide by 1000 to get seconds
	  sectogo = (uint32_t) floor(d / 1000.);


      }
    if (n != lastper)
    {
      float f;
      int  mm,ss;
    	lastper = n;
     	mm=sectogo/60;
      	ss=sectogo%60;
    	sprintf(b, " %d m %d s left", mm,ss);
    	gtk_label_set_text(GTK_LABEL(label_timeleft), b);
     	// then update progress bar
      	f=(float)n;
       f=f/100.;
       gtk_progress_set_percentage(GTK_PROGRESS(progressbar1),(gfloat)f);
    } 	
    while (gtk_events_pending())
      {
	  gtk_main_iteration();
      }
    return abort_flag;
}

int GUI_UpdateWorking(uint32_t made, uint32_t total)
{
    double db;
    int i;
    if (!total)
	return 0;
    db = made;
    db *= 100;
    db /= total;
    i = (int) floor(db);
    return GUI_UpdateWorking(i);

}


void on_work_abort(GtkObject * object, gpointer user_data)
{
    UNUSED_ARG(object);
    UNUSED_ARG(user_data);
    abort_flag = 1;
};
void on_work_destroy(GtkObject * object, gpointer user_data)
{
    UNUSED_ARG(object);
    UNUSED_ARG(user_data);
    abort_flag = 1;
    working=NULL;
};


GtkWidget*
create_working (void)
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *label1;
  GtkWidget *dialog_action_area1;
  GtkWidget *button_abort;

  dialog1 = gtk_dialog_new ();
 // gtk_object_set_data (GTK_OBJECT (dialog1), "dialog1", dialog1);
   gtk_object_set_data_full(GTK_OBJECT(dialog1),
			     "dialog1", dialog1 ,
			     (GtkDestroyNotify) on_work_destroy);
  gtk_window_set_modal(GTK_WINDOW(dialog1),1);
  gtk_window_set_title (GTK_WINDOW (dialog1), "Working...");
  gtk_window_set_policy (GTK_WINDOW (dialog1), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox1, TRUE, TRUE, 0);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);
  gtk_widget_set_usize (hbox1, -2, 20);

  label1 = gtk_label_new ("Time left :");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox1), label1, TRUE, TRUE, 0);
  gtk_widget_set_usize (label1, -2, 20);

  label_timeleft = gtk_label_new ("??");
  gtk_widget_ref (label_timeleft);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "label_timeleft", label_timeleft,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_timeleft);
  gtk_box_pack_start (GTK_BOX (hbox1), label_timeleft, TRUE, TRUE, 0);
  gtk_widget_set_usize (label_timeleft, -2, 20);

  progressbar1 = gtk_progress_bar_new ();
  gtk_widget_ref (progressbar1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "progressbar1", progressbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (progressbar1);
  gtk_box_pack_start (GTK_BOX (vbox1), progressbar1, FALSE, FALSE, 0);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  button_abort = gtk_button_new_with_label ("Abort");
  gtk_widget_ref (button_abort);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_abort", button_abort,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_abort);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), button_abort, FALSE, FALSE, 0);

   gtk_signal_connect(GTK_OBJECT(button_abort), "clicked",
		       GTK_SIGNAL_FUNC(on_work_abort), (void *) 1);

  return dialog1;
}


//

