/***************************************************************************
                          GUI_mp3.cpp  -  description
                             -------------------
    begin                : Sat Apr 13 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "avi_vars.h"

static GtkWidget *create_window_mp3(char *title, int oldbr,int oldmode);

#define NB_BITRATE 10

static int BTR[NB_BITRATE] = {		// see interface.c if you change this !
		48,
		56,
		64,
		80,
    96,
    112,
    128,
    160,
    192,
    224
};
static int mp3lock;
static GtkWidget *mp3_bitrate;
static GtkWidget *mp3_mode;
extern uint8_t getRangeInMenu(GtkWidget * Menu);
extern void MenuAppend(GtkMenu * menu, const char *text);
extern void runDialog(volatile int *a);

void on_mp3_callback_ko(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    UNUSED_ARG(user_data);
    on_mp3CallBack(NULL, (gpointer) 0);

}

void on_mp3CallBack(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    int res;

    res = (int) user_data;
    if (mp3lock)
	return;			// second call back->ignore.
    switch (res)
      {
      case 1:
	  mp3lock = 1;
	  //gtk_hide_widget(wdg);

	  break;
      case 0:
	  mp3lock = -1;
	  break;
      }
    return;

};

int getmp3parameter(int *pmode, int *pbitrate,const char *title)
{
    static GtkWidget *wdg;
    int mode, bitrate;

    wdg = create_window_mp3((char *)title,*pbitrate,*pmode);
    mp3lock = 0;
    gtk_widget_show(wdg);

    runDialog(&mp3lock);
    
    if (mp3lock == 1)
      {
	  // retrieve value
	mode = (int) getRangeInMenu(mp3_mode);
	bitrate = (int) getRangeInMenu(mp3_bitrate);
	printf(" MB  : %d / MM %d\n", mode,bitrate);
   	*pmode = (int) ADM_STEREO;
	  if (mode == 0)
	      *pmode = (int) ADM_STEREO;
	  else
	      *pmode = (int) ADM_JSTEREO;
	  *pbitrate = BTR[bitrate];

	  printf(" bitrate : %d / %d\n", *pbitrate,bitrate);
 	  printf(" Mode : %d / %d\n", *pmode,mode);

	  // now we got the menu item selected
	  gtk_widget_destroy(wdg);
	  return 1;
      }
    return 0;
}

GtkWidget *create_window_mp3(char *title, int oldbr,int oldmode)
{
    GtkWidget *window_mp3;
    GtkWidget *vbox4;
    GtkWidget *label12;
    GtkWidget *hbox5;
    GtkWidget *vbox5;
    GtkWidget *label13;
//  GtkWidget *mp3_bitrate;
    GtkWidget *mp3_bitrate_menu;
//  GtkWidget *glade_menuitem;
    GtkWidget *vbox6;
    GtkWidget *label14;
//  GtkWidget *mp3_mode;
    GtkWidget *mp3_mode_menu;
    GtkWidget *mp3_set_ok;

    window_mp3 = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    //gtk_object_set_data (GTK_OBJECT (window_mp3), "window_mp3", window_mp3);
    gtk_object_set_data_full(GTK_OBJECT(window_mp3),
			     "window_mp3",
			     window_mp3,
			     (GtkDestroyNotify) on_mp3_callback_ko);
    gtk_window_set_title(GTK_WINDOW(window_mp3), title ); //"MP3 Settings");

    vbox4 = gtk_vbox_new(FALSE, 0);
    gtk_widget_ref(vbox4);
    gtk_object_set_data_full(GTK_OBJECT(window_mp3), "vbox4", vbox4,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(vbox4);
    gtk_container_add(GTK_CONTAINER(window_mp3), vbox4);
    gtk_widget_set_usize(vbox4, 200, 150);

    label12 = gtk_label_new("Encoder Settings");
    gtk_widget_ref(label12);
    gtk_object_set_data_full(GTK_OBJECT(window_mp3), "label12", label12,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(label12);
    gtk_box_pack_start(GTK_BOX(vbox4), label12, FALSE, FALSE, 0);
    gtk_widget_set_usize(label12, -2, 40);

    hbox5 = gtk_hbox_new(FALSE, 0);
    gtk_widget_ref(hbox5);
    gtk_object_set_data_full(GTK_OBJECT(window_mp3), "hbox5", hbox5,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(hbox5);
    gtk_box_pack_start(GTK_BOX(vbox4), hbox5, TRUE, TRUE, 0);
    gtk_widget_set_usize(hbox5, -2, 24);

    vbox5 = gtk_vbox_new(FALSE, 0);
    gtk_widget_ref(vbox5);
    gtk_object_set_data_full(GTK_OBJECT(window_mp3), "vbox5", vbox5,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(vbox5);
    gtk_box_pack_start(GTK_BOX(hbox5), vbox5, TRUE, FALSE, 0);

    label13 = gtk_label_new("Bitrate");
    gtk_widget_ref(label13);
    gtk_object_set_data_full(GTK_OBJECT(window_mp3), "label13", label13,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(label13);
    gtk_box_pack_start(GTK_BOX(vbox5), label13, FALSE, FALSE, 0);

    mp3_bitrate = gtk_option_menu_new();
    gtk_widget_ref(mp3_bitrate);
    gtk_object_set_data_full(GTK_OBJECT(window_mp3), "mp3_bitrate",
			     mp3_bitrate,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(mp3_bitrate);
    gtk_box_pack_start(GTK_BOX(vbox5), mp3_bitrate, FALSE, FALSE, 0);
    gtk_widget_set_usize(mp3_bitrate, -2, 24);
    gtk_container_set_border_width(GTK_CONTAINER(mp3_bitrate), 1);

    mp3_bitrate_menu = gtk_menu_new();
//____________
    // see callback.c if you change this
// sorry , quick hack
		for(uint32_t i=0;i<NB_BITRATE;i++)
		{
			static char string[200];
					sprintf(string,"%d Kbps",BTR[i]);
					 MenuAppend(GTK_MENU(mp3_bitrate_menu), string);
  	}
   /*
    MenuAppend(GTK_MENU(mp3_bitrate_menu), "96 Kbps");
    MenuAppend(GTK_MENU(mp3_bitrate_menu), "112 Kbps");
    MenuAppend(GTK_MENU(mp3_bitrate_menu), "128 Kbps");
    MenuAppend(GTK_MENU(mp3_bitrate_menu), "160 Kbps");
    MenuAppend(GTK_MENU(mp3_bitrate_menu), "192 Kbps");
    MenuAppend(GTK_MENU(mp3_bitrate_menu), "224 Kbps");
    */
//_____________
    gtk_option_menu_set_menu(GTK_OPTION_MENU(mp3_bitrate),
			     mp3_bitrate_menu);
    for(uint32_t j=0;j<NB_BITRATE;j++)
    {
				if(BTR[j]==oldbr)			     
			    gtk_option_menu_set_history(GTK_OPTION_MENU(mp3_bitrate), j);
    }

    vbox6 = gtk_vbox_new(FALSE, 0);
    gtk_widget_ref(vbox6);
    gtk_object_set_data_full(GTK_OBJECT(window_mp3), "vbox6", vbox6,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(vbox6);
    gtk_box_pack_start(GTK_BOX(hbox5), vbox6, TRUE, FALSE, 0);

    label14 = gtk_label_new("Mode");
    gtk_widget_ref(label14);
    gtk_object_set_data_full(GTK_OBJECT(window_mp3), "label14", label14,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(label14);
    gtk_box_pack_start(GTK_BOX(vbox6), label14, FALSE, FALSE, 0);

    mp3_mode = gtk_option_menu_new();
    gtk_widget_ref(mp3_mode);
    gtk_object_set_data_full(GTK_OBJECT(window_mp3), "mp3_mode", mp3_mode,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(mp3_mode);
    gtk_box_pack_start(GTK_BOX(vbox6), mp3_mode, FALSE, FALSE, 0);
    gtk_widget_set_usize(mp3_mode, -2, 24);
    mp3_mode_menu = gtk_menu_new();

//__________
    MenuAppend(GTK_MENU(mp3_mode_menu), "Stereo");
    MenuAppend(GTK_MENU(mp3_mode_menu), "J-Stereo");
    gtk_option_menu_set_menu(GTK_OPTION_MENU(mp3_mode), mp3_mode_menu);
    if(oldmode==(int)ADM_JSTEREO)
    {
    	printf("\n Jstereo\n");
  	gtk_option_menu_set_history(GTK_OPTION_MENU(mp3_mode), 1);
    }
   

//_______________
    mp3_set_ok = gtk_button_new_with_label("Ok");
    
    gtk_widget_ref(mp3_set_ok);
    
    gtk_object_set_data_full(GTK_OBJECT(window_mp3), "mp3_set_ok",
			     mp3_set_ok,
			     (GtkDestroyNotify) gtk_widget_unref);
			     
    gtk_widget_show(mp3_set_ok);
    
    gtk_box_pack_start(GTK_BOX(vbox4), mp3_set_ok, TRUE, FALSE, 0);
    gtk_window_set_modal(GTK_WINDOW(window_mp3), TRUE);

    gtk_signal_connect(GTK_OBJECT(mp3_set_ok), "clicked",
		       GTK_SIGNAL_FUNC(on_mp3CallBack), (void *) 1);


    return window_mp3;
}
