/***************************************************************************
                          ADM_pics.cpp  -  description
                             -------------------

                             Open a bunch of bmps and read them as a movie
                             Useful for people doing raytracing or doing img/img
                             modifications


    begin                : Tue Jun 4 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "config.h"
#include "math.h"

#include "ADM_library/default.h"
#include "ADM_editor/ADM_Video.h"


#include "ADM_library/fourcc.h"
#include "ADM_inpics/ADM_pics.h"
#include "ADM_inpics/bitmap.h"

static	uint16_t s16;
static	uint32_t s32;

uint8_t  picHeader::getFrameNoAlloc(uint32_t framenum,uint8_t *ptr,uint32_t* framelen,
												uint32_t *flags)
            {
               	*flags=AVI_KEY_FRAME;
                	return getFrameNoAlloc(  framenum,ptr,framelen);
              }
uint8_t  picHeader::getFrameNoAlloc(uint32_t framenum,uint8_t *ptr,uint32_t* framelen)
{
	assert(framenum<=_nb_file);

 	fseek(_fd[framenum],_offset,SEEK_SET);
 	fread(ptr,
  							_mainaviheader.dwWidth*_mainaviheader.dwHeight*3,
         					1,
              			_fd[framenum]);
  	*framelen=_mainaviheader.dwWidth*_mainaviheader.dwHeight*3;

 	return 1;
}

uint8_t    picHeader::close( void )
{
	if(_fd)
 		{
        	for(uint32_t i=0;i<_nb_file;i++)
         		{
               	fclose(_fd[i]);
             	}
              free(_fd);
              _fd=NULL;

     	}
 	return 0;
}
uint8_t    picHeader::open(char *name)
{

uint32_t nnum;
 	// decompose the file
  	if(strcmp(name+strlen(name)-4,".bmp"))
   {
     	printf("\n Not a BMP File !");
   		return 0;
     }

     *(name+strlen(name)-4)=0;

     char *end;
     nnum=1;

     end=name+strlen(name)-1;
     while(( *end>='0') && (*end<='9'))
     		{
            	end--;
              nnum++;
         	};
      if(nnum==1)
      	{
          	printf("\n only one file!");
           return 0;

         }
        nnum--;
        end++;
       _first=atoi(end);
       printf("\n First : %lu, num digit :%lu",_first,nnum);
       *(end)=0;
       printf("\n Path : %s",name);

       char realname[250];
       char realstring[250];

            	sprintf(realstring,"%%s%%0%lud.bmp",nnum);
              printf("\n string : %s",realstring);

       _nb_file=0;
       FILE *fd;
       for(uint32_t i=0;i<999;i++)
       	{
              sprintf(realname,realstring,name,i+_first);
              printf("\n %lu : %s",i,realname);
              fd=fopen(realname,"rb");
              if(fd==NULL) break;
              fclose(fd);
              _nb_file++;
          	}
			printf("\n found %lu images\n",_nb_file);
//           _fd=new *FILE[_nb_file];
			_fd=(FILE **)malloc(_nb_file*sizeof(FILE*));
          // now open them and assign fd
          for(uint32_t i=0;i<_nb_file;i++)
          {
              sprintf(realname,realstring,name,i+_first);
              printf("\n %lu : %s",i,realname);
              _fd[i]=fopen(realname,"rb");
              assert(_fd[i]!=NULL);
            }

            // Take info from the first one
          //   	BITMAPFILEHEADER bmfh;
			    BITMAPHEADER bmph;
       	
              fread(&s16,2,1, _fd[0]);
              if(s16!=0x4D42)
              {
                	printf("\n incorrect bmp sig.\n");
              	return 0;
               }
              fread(&s32,4,1, _fd[0]);
              fread(&s32,4,1, _fd[0]);
              fread(&s32,4,1, _fd[0]);
               fread(&bmph, sizeof(bmph), 1, _fd[0]);
               if(bmph.compressionScheme!=0)
               {
                 	printf("\ncannot handle compressed bmp\n");
	               return 0;
                }
              _offset=bmph.size+14;

//
//		Now build header info
//
 				_isaudiopresent=0; // Remove audio ATM
              _isvideopresent=1; // Remove audio ATM

#define CLR(x)              memset(& x,0,sizeof(  x));

               CLR( _videostream);
               CLR(  _mainaviheader);

    			_videostream.dwScale=1;
              _videostream.dwRate=25;
              _mainaviheader.dwMicroSecPerFrame=40000;;     // 25 fps hard coded
              _videostream.fccType=fourCC::get((uint8_t *)"vids");
              _video_bih.biCompression=0;
               _video_bih.biBitCount=24;
              _videostream.fccHandler=0;
              _videostream.dwLength= _mainaviheader.dwTotalFrames=_nb_file;
               _videostream.dwInitialFrames= 0;
               _videostream.dwStart= 0;
               //
               //_video_bih.biCompression= 24;
               //
               _video_bih.biWidth=_mainaviheader.dwWidth=bmph.width ;
               _video_bih.biHeight=_mainaviheader.dwHeight=bmph.height;
               //_video_bih.biPlanes= 24;

       return 1;




}

uint8_t picHeader::setFlag(uint32_t frame,uint32_t flags){
    UNUSED_ARG(frame);
    UNUSED_ARG(flags);
	return 0;
}

uint32_t picHeader::getFlags(uint32_t frame,uint32_t *flags){
    UNUSED_ARG(frame);
	*flags=AVI_KEY_FRAME;
	return 1;
}








