/***************************************************************************
                          ADM_mpeg2decframes.cpp  -  description
                             -------------------
    begin                : Sat Nov 2 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 #include <stdio.h>
#ifdef HAVE_SYS_PARAM_H
#include <sys/param.h>
#endif
#ifdef __FreeBSD__
          #include <sys/types.h>
#endif
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "config.h"
#include <math.h>

#include "ADM_library/default.h"
#include "avifmt.h"
#include "avifmt2.h"

#include "ADM_editor/ADM_Video.h"
#include "ADM_audio/aviaudio.hxx"

#include "ADM_library/fourcc.h"
#include "ADM_mpeg2dec/ADM_mpegscan.h"
#include "ADM_mpeg2dec/ADM_mpegpacket_PS.h"
#include "ADM_mpeg2dec/ADM_mpegAudio.h"

#include "ADM_toolkit/toolkit.hxx"

#define W _mainaviheader.dwWidth
#define H _mainaviheader.dwHeight

#define TRANSLATE

 //-----------------------------------
//-----------------------------------

uint8_t  mpeg2decHeader::setFlag(uint32_t frame,uint32_t flags)
{
        UNUSED_ARG(frame);
    	UNUSED_ARG(flags);
		return 0;
};
//-----------------------------------
//
//	Return the I frame starting the GOP in which in is
// in is display, return is index
//
//-----------------------------------
uint8_t  	mpeg2decHeader::getRaw(uint32_t framenum,uint8_t *ptr,uint32_t* framelen)
{
// rewind to the last know frame I
	
//	printf("\n seeking\n");	
	if(framenum)
	{
		uint32_t i=framenum;
		
			while(i && _indexMpegPTS[i].type!='I') i--;
			asyncJump(i);			
	}
//	printf("\n going\n");
	demuxer->goTo(_indexMpegPTS[framenum].offset);
//	printf("\n reading\n");
	demuxer->read(ptr,_indexMpegPTS[framenum].size);
	*framelen= _indexMpegPTS[framenum].size;
	return 1;
	
}
uint8_t   mpeg2decHeader::getRawStart(uint8_t *ptr,uint32_t *len)
{
		
		 *len=_startSeqLen;
		 memcpy(ptr,_startSeq,_startSeqLen);
		 return 1;
}				

uint32_t mpeg2decHeader::getFlags(uint32_t frame,uint32_t *flags)
{
	//uint32_t j=0;
	*flags=0;
	if(frame>=(uint32_t)_videostream.dwLength)
		{
				printf("\n out of bound !");
				return 0;
		}
		
	switch(_indexMpegPTS[frame].type)
	{
			case 'I': *flags=AVI_KEY_FRAME; break;
			case 'P': *flags=0; break;
			case 'B': *flags=AVI_B_FRAME; break;
			default:
					assert(0);		
	}
	return 1;										 

};	
//-----------------------------------
//-----------------------------------

uint8_t  	mpeg2decHeader::getFrameNoAlloc(uint32_t framenum,uint8_t *ptr,uint32_t* framelen)
//-----------------------------------
//-----------------------------------

{
	return   getFrameNoAlloc( framenum,ptr,framelen,NULL);	     	 		
}
// Feed "feed" bytes to mpegdecoder
//-----------------------------------

uint8_t  mpeg2decHeader::feedData(uint32_t feed)
{
//uint32_t chunk=0,rd=0;	  	
			assert(MP2D_BUFFER_SIZE>feed);
			demuxer->read(_buffer,feed);
 		 	decode_mpeg2(_buffer,_buffer+feed);				
		return 1;	
}

//-----------------------------------
//
//
//-----------------------------------

uint8_t  mpeg2decHeader::getFrameNoAlloc(uint32_t framenum,uint8_t *ptr,uint32_t* framelen,
												uint32_t *flags)
{
//static int f=0;
uint8_t /*end=0,*/cache=0;
//uint32_t rd,loop=0;
//uint32_t feed;
//uint32_t gop, offset;

		if(flags)
			{   
					*flags=0;
			}					
  		        *framelen= _pagesize;
				// here we go, first check
		if(framenum>= _nbFrames)
			{
					printf("\n Mpeg out of bound ! (%ld/%ld)\n",framenum,_nbFrames);
					return 0;
			}
		getFlags(framenum,flags);
		// check if it is already in cache
			if(isInCache(framenum,&cache) )
			{
#ifdef VERBOSE_ACCESS			
				printf("Cache access\n");
#endif				
				memcpy(ptr,_frame[cache],_pagesize);
								
				return 1;				
			}
			// last frame may be broken, ignore it
			if(framenum==_nbFrames-1) return 1;			
			// Is the last frame the next one ?
			if(_lastFrame+1==framenum) // sequential access
			{
#ifdef VERBOSE_ACCESS			
				printf("Sequential access\n");
				printf("\t%c\n",_indexMpegPTS[framenum].type);
#endif				
				// in that case we look up the frame. If it is P or I just send it
				// and extract forward frame
				switch(_indexMpegPTS[framenum].type)
				{
#define PUMPPTS(x) {demuxer->goTo(_indexMpegPTS[x].offset);feedData(_indexMpegPTS[x].size);pop();}							
#define PUMPIPTS(x) {demuxer->goTo(_indexMpegPTS[x].offset);feedData(_indexMpegPTS[x].size);popI();}							
				
					case 'I':
					case 'P':
							 _awaited=framenum;
					 		PUMPIPTS(framenum);	  
							_lastFrame=framenum;    
							  	
							return gotcha(framenum,ptr);;
							break;
					case 'B' :	
							{
							uint32_t nextIP=framenum+1;
							
							_awaited=framenum;
							// lookup next i-p
							
							
							while(_indexMpegPTS[nextIP].type=='B') nextIP++;
							
							demuxer->goTo(_indexMpegPTS[nextIP].offset);
							feedData(_indexMpegPTS[nextIP].size);
							
							for(uint32_t z=framenum;z<nextIP;z++)												
							{
								PUMPPTS(z);	  
							}
							popI(); // get P/I end frame
							_lastFrame=nextIP;
							return gotcha(framenum,ptr);
							
							}
							break;
					default:
							assert(0);	
							return 0;
							break;						
				}						
			}
			
			// out of order frame ... read
			// I frame ?
			if('I' == _indexMpegPTS[framenum].type)
			{
#ifdef VERBOSE_ACCESS			
				printf("Out of order I access\n");
#endif				
				if(!asyncJump(framenum)) return 0;
				_awaited=framenum;
				PUMPIPTS(framenum);	  
				_lastFrame=framenum;     
				return gotcha(framenum,ptr); 	
				return 1;
			}
			// random access : We go back to last I frame and decode forward
#ifdef VERBOSE_ACCESS			
			printf("Out of order XX access\n");
#endif				
			uint32_t li;
			assert(framenum);
			li=framenum-1;
			purgeCache();
			while(_indexMpegPTS[li].type!='I') li--;					
			// the decode forward
			if(!asyncJump(li)) return 0;
			for(uint32_t j=li;j<=framenum;j++)
			{
#ifdef VERBOSE_ACCESS			
				printf("rewinding %ld ****\n",j);
#endif			
				getFrameNoAlloc(j,ptr,framelen,flags);
			}
			_lastFrame=framenum;
			return gotcha(framenum,ptr);
}	
uint8_t	mpeg2decHeader::asyncJump(uint32_t frame)
{
		assert(_indexMpegPTS[frame].type=='I');
		 if(!demuxer->_asyncJump(_indexMpegPTS[frame].offset,
                                                                _indexMpegPTS[frame].absoffset))
			{
					printf("\n Asynchronous jump failed ! (frame : %ld)\n",frame);
			
			}
		return 1;                                                                      
	


}							
uint8_t   mpeg2decHeader::gotcha(uint32_t frame,uint8_t *out)
{
	uint8_t cache;	
		if(isInCache(frame,&cache))
		{
			memcpy(out,_frame[cache],_pagesize);
			return 1;				
		}
		printf("\n gotcha failed : Wanted %lu\n",frame);
		printf("\n Offset :%llu size : %lu\n",_indexMpegPTS[frame].offset,_indexMpegPTS[frame].size);
		dumpCache();
		return 0;	
}
//EOF
