/***************************************************************************
                          ADM_mpegcache.cpp  -  description
                             -------------------
    begin                : Sun Oct 13 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
    This part handles the mpeg decoder cache
    As a full GOP is potentially decoded , we have to store frames to avoid
    	decoding it again and again
     Can be huge.... 
    
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 #include <stdio.h>
#ifdef HAVE_SYS_PARAM_H
#include <sys/param.h>
#endif
#ifdef __FreeBSD__
          #include <sys/types.h>
#endif
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "config.h"
#include <math.h>

#include "ADM_library/default.h"
#include "avifmt.h"
#include "avifmt2.h"

#include "ADM_editor/ADM_Video.h"
#include "ADM_audio/aviaudio.hxx"

#include "ADM_library/fourcc.h"
#include "ADM_mpeg2dec/ADM_mpegscan.h"
#include "ADM_toolkit/toolkit.hxx"

#define W _mainaviheader.dwWidth
#define H _mainaviheader.dwHeight
uint8_t mpeg2decHeader::dumpCache(void)
{
	for(uint8_t y=0;y<MG_CACHE;y++)
	{
			printf("Entry : %d Frame  : %ld\n",y,_frameno[y]);				
	}
	return 1;

}

uint8_t mpeg2decHeader::isInCache(uint32_t frame, uint8_t *no)
{
	*no=0xff;
	for(uint8_t y=0;y<MG_CACHE;y++)
	{
			if(_frameno[y]==frame)
					{
							*no=y;return 1;
					}
	}
	return 0;
}
/*
   Return the far-er cache entry from frame frame
*/
uint8_t mpeg2decHeader::getCacheEntry(uint32_t frame, uint8_t *no)
{
	*no=0xff;
	uint32_t max=0;
	int delta;
	
	for(uint8_t y=0;y<MG_CACHE;y++)
	{
			delta= _frameno[y]-frame;
			if((uint32_t)abs(delta)>max)
					{
							max=abs(delta);
							*no=y;
					}
	}
	assert(*no!=0xff);
	_frameno[*no]=0xffffffff;
	return 1;
}
/*
    Get smaller frame # in cache
*/
uint32_t mpeg2decHeader::getSmallerCached(void)
{
	uint32_t small=0xffffffff;

		for(uint8_t y=0;y<MG_CACHE;y++)
	{
			if(_frameno[y]<small)
					{
							small=_frameno[y];
					}
	}
	if(small==0xffffffff) small=0; // empty
//	printf("\n smaller : %lu\n",small);
	return small;
}
/*

*/
uint8_t mpeg2decHeader::purgeCache(void)
{
	
	for(uint8_t y=0;y<MG_CACHE;y++)
	{		
	_frameno[y]=0xffffffff;
	}
	return 1;
	
}


/*
    Push a frame in cache
*/
uint8_t mpeg2decHeader::push(uint8_t *in)
{
		// 
		uint8_t i;
		uint32_t sz;
		
		if(_ignore) 
			{
					_ignore--;
						return 1;
			}
		sz=_pagesize;
//		printf("\n pushing frame %lu\n",_awaited);
		assert( getCacheEntry(_awaited,&i));
//		printf("\n go cache entry %d\n",i);		
		_frameno[i]=_awaited;					
		memcpy(_frame[i],in,sz);
//				printf(" put %lu frame in buffer %d\n",_awaited,i);
		_awaited++;
		return 1;
	
}
