/***************************************************************************
                          ADM_guiContrast.cpp  -  description
                             -------------------
    begin                : Mon Sep 23 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <gtk/gtk.h>
#include <time.h>
#include <sys/time.h>
#include <assert.h>
#include <math.h>


#include "fourcc.h"
#include "avio.hxx"
#include "config.h"
#include "avi_vars.h"
#ifdef HAVE_ENCODER


#include "ADM_editor/ADM_edit.hxx"
#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_video/ADM_vidContrast.h"

extern void yv12rgb(uint8_t *in,uint8_t *out,uint32_t w, uint32_t h);
extern void GUI_RGBDisplay(uint8_t * dis, uint32_t w, uint32_t h, void *widg);

//static void 				gui_ko(GtkButton * button, gpointer user_data);
static void 				gui_ok(GtkButton * button, gpointer user_data);
static int 					getContrastParams(	void);
																				
static GtkWidget*  create_dialog1 (void);
static gboolean  			gui_draw(GtkWidget * widget,
	     GdkEventExpose * event, gpointer user_data);

static int croplock;

static  GtkWidget *checkbutton_Y=NULL;
static  GtkWidget *checkbutton_U=NULL;
static  GtkWidget *checkbutton_V=NULL;
static  GtkWidget *drawing=NULL;
static  GtkWidget *hscale3=NULL;
static  GtkWidget *hscale2=NULL;
static  GtkObject *adj_offset=NULL;    
static  GtkObject *adj_coeff=NULL;    


static void gui_update(GtkButton * button, gpointer user_data);


// Ugly !
static uint8_t *video1,*video2,*video3;
static uint32_t sw,sh;
static CONTRAST_PARAM par;

static uint8_t tableluma[256],tablechroma[256];

void *ADMVideoContrast::configure( AVDMGenericVideoStream *instream)

{
uint32_t w,h,l,f;


							video1=video2=NULL;

		                 // Get info from previous filter
							w= _in->getInfo()->width;
							h= _in->getInfo()->height;
						

							video2=(uint8_t *)malloc(w*h*3);							
							assert(video2);
							video1=(uint8_t *)malloc(w*h*3);							
							assert(video1);
    					video3=(uint8_t *)malloc(w*h*3);							
							assert(video1);

							
							// ask current frame from previous filter
							assert(instream->getFrameNumberNoAlloc(curframe, &l,
          																				video1,&f));
						
							// From now we work in RGB !
							memcpy(video2,video1,w*h*3);
							
              yv12rgb(video2,video3, w,h);
				
						assert(_param);			
						memcpy(&par,_param,sizeof(par));
						sw=w;
						sh=h;
		
    	 	switch(getContrastParams())
				{
				case 0:
		      		printf("cancelled\n");	       	
					break;
				case 1:
							memcpy(_param,&par,sizeof(par));
					break;
				default:
					assert(0);
				}
		
					free(video1);
					free(video2);
					free(video3);

					video1=video2=video3=NULL;

				  buildContrastTable( _param->coef,_param->offset,_tableFlat,_tableNZ);

					return (void *)_param;

}
//
//      Get crop parameters from GUI
//                         left, right, top, down , initial size
//
int getContrastParams(	void )
{
//char 	string[50];
//gchar   *str;
static 	GtkWidget *resi;
//int 	ret;

	
		do
		{
			croplock=0;
			resi=create_dialog1();
			gtk_widget_set_usize(drawing, sw, sh);		
      /*
         Update value
      */		      
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (checkbutton_Y), par.doLuma);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (checkbutton_U), par.doChromaU);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (checkbutton_V), par.doChromaV);
    GTK_ADJUSTMENT(adj_offset)->value= par.offset ;
   	GTK_ADJUSTMENT(adj_coeff)->value= par.coef ;

   	gtk_widget_show(resi);
                   
			while(!croplock)
					gtk_main_iteration();
			// now check parameters
			//
			if(1==croplock) //         ok button
			{
			      par.doLuma=			gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (checkbutton_Y));
				    par.doChromaU=	gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (checkbutton_U));
				    par.doChromaV=	gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (checkbutton_V));
				    
				    par.coef= GTK_ADJUSTMENT(adj_coeff)->value;
					  par.offset=(int8_t)floor( GTK_ADJUSTMENT(adj_offset)->value  );
					  
					//  printf("\n Luma : %d,u %d, v:%d",par.doLuma,par.doChromaU,par.doChromaV);
 					//  printf("\n off : %d, coeff %f\n",par.offset,par.coef);

			}
			// cancel button
			if(croplock!=-1)
				 	gtk_widget_destroy(resi);
		}while(!croplock);
	// exit ok
	if(croplock==1)
		return 1;
  return 0;
}
//
//        Check entered values and green-out the selected portion on the screen
//        Each value must be even
//
void gui_update(GtkButton * button, gpointer user_data)
{
UNUSED_ARG(button);
UNUSED_ARG(user_data);
uint32_t sz;

		sz=sw*sh;
	   	      par.doLuma=			gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (checkbutton_Y));
				    par.doChromaU=	gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (checkbutton_U));
				    par.doChromaV=	gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (checkbutton_V));
				    
				    par.coef= GTK_ADJUSTMENT(adj_coeff)->value;
					  par.offset=(int8_t)floor( GTK_ADJUSTMENT(adj_offset)->value  );
					  
					 // printf("\n Luma : %d,u %d, v:%d",par.doLuma,par.doChromaU,par.doChromaV);
 					 // printf("\n off : %d, coeff %f\n",par.offset,par.coef);

         buildContrastTable( par.coef,par.offset,	
  								tableluma,tablechroma);
        
       memcpy(video2,video1,sh*sw*3);
       if( par.doLuma)
       		{
					  doContrast(video1,video2,
					  			tableluma,
					     		sw,sh);

					 }
       if( par.doChromaU)
       		{
					  doContrast(video1+sz,video2+sz,
					  			tablechroma,
					     		sw>>1,sh>>1);
					 }
					 
       if( par.doChromaV)
       		{
					  doContrast(video1+sz+(sz>>2),video2+sz+(sz>>2),
					  			tablechroma,
					     		sw>>1,sh>>1);
					 }

		yv12rgb(video2,video3,sw,sh);			 
	 	GUI_RGBDisplay(video3, sw,sh,( void *)drawing);


}

/*
void gui_ko(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    UNUSED_ARG(user_data);
	if(croplock==0)
		croplock=-1;
}
*/

gboolean  gui_draw(GtkWidget * widget,
			     GdkEventExpose * event, gpointer user_data)
{
    UNUSED_ARG(widget);
    UNUSED_ARG(event);
    UNUSED_ARG(user_data);

	 	GUI_RGBDisplay(video3, sw,sh,( void *)drawing);
    	return TRUE;
}

void gui_ok(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    int res;

    res = (int) user_data;
    if (croplock)
			return;			// second call back->ignore.
			
    switch (res)
      {
      case 1:
	  croplock = 1;
	  break;
      case 0:
	  croplock = -2;
	  break;
      }
    return;

};

 
GtkWidget*  create_dialog1 (void)
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *hbox2;
  GtkWidget *vbox3;
  GtkWidget *vbox4;
  GtkWidget *label1;
//  GtkWidget *hscale2;
  GtkWidget *vbox5;
  GtkWidget *label2;
//  GtkWidget *hscale3;
  GtkWidget *vbox2;
//  GtkWidget *checkbutton_Y;
//  GtkWidget *checkbutton_U;
//  GtkWidget *checkbutton_V;
//  GtkWidget *drawing;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbox1;
  GtkWidget *button_ok;
  GtkWidget *button_cancel;
  GtkWidget *button_update;

  dialog1 = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog1", dialog1);
  gtk_window_set_title (GTK_WINDOW (dialog1), "BrightnessContrast");
  gtk_window_set_policy (GTK_WINDOW (dialog1), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox1, TRUE, TRUE, 0);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 0);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (hbox2), vbox3, TRUE, TRUE, 0);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_box_pack_start (GTK_BOX (vbox3), vbox4, TRUE, TRUE, 0);

  label1 = gtk_label_new ("Contrast");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox4), label1, FALSE, FALSE, 0);

  // coef  _______________________________________________________________
  adj_coeff=gtk_adjustment_new (1.5, 0, 2, 0.1, 0.1, 0.1);
  hscale2 = gtk_hscale_new (GTK_ADJUSTMENT (adj_coeff));
  gtk_widget_ref (hscale2);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "hscale2", hscale2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hscale2);
  gtk_box_pack_start (GTK_BOX (vbox4), hscale2, TRUE, TRUE, 0);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_box_pack_start (GTK_BOX (vbox3), vbox5, TRUE, TRUE, 0);

  label2 = gtk_label_new ("Brightness");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (vbox5), label2, FALSE, FALSE, 0);

  /* ---------------offset _____________________________________________________*/
  adj_offset= gtk_adjustment_new (-0, -127, 127, 1, 1, 1);
  hscale3 = gtk_hscale_new (GTK_ADJUSTMENT(adj_offset));
  gtk_widget_ref (hscale3);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "hscale3", hscale3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hscale3);
  
  
  gtk_box_pack_start (GTK_BOX (vbox5), hscale3, TRUE, TRUE, 0);
  gtk_scale_set_digits (GTK_SCALE (hscale3), 0);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (hbox2), vbox2, TRUE, TRUE, 0);

  checkbutton_Y = gtk_check_button_new_with_label ("Luma");
  gtk_widget_ref (checkbutton_Y);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "checkbutton_Y", checkbutton_Y,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton_Y);
  gtk_box_pack_start (GTK_BOX (vbox2), checkbutton_Y, FALSE, FALSE, 0);

  checkbutton_U = gtk_check_button_new_with_label ("Chroma U");
  gtk_widget_ref (checkbutton_U);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "checkbutton_U", checkbutton_U,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton_U);
  gtk_box_pack_start (GTK_BOX (vbox2), checkbutton_U, FALSE, FALSE, 0);

  checkbutton_V = gtk_check_button_new_with_label ("Chroma V");
  gtk_widget_ref (checkbutton_V);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "checkbutton_V", checkbutton_V,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton_V);
  gtk_box_pack_start (GTK_BOX (vbox2), checkbutton_V, FALSE, FALSE, 0);

  drawing = gtk_drawing_area_new ();
  gtk_widget_ref (drawing);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "drawing", drawing,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (drawing);
  gtk_box_pack_start (GTK_BOX (vbox1), drawing, TRUE, TRUE, 0);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbox1, TRUE, TRUE, 0);

  button_ok = gtk_button_new_with_label ("Ok");
  gtk_widget_ref (button_ok);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_ok", button_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_ok);
  gtk_box_pack_start (GTK_BOX (hbox1), button_ok, FALSE, FALSE, 0);

  button_cancel = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (button_cancel);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_cancel", button_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_cancel);
  gtk_box_pack_start (GTK_BOX (hbox1), button_cancel, FALSE, FALSE, 0);

  button_update = gtk_button_new_with_label ("Update");
  gtk_widget_ref (button_update);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_update", button_update,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_update);
  gtk_box_pack_start (GTK_BOX (hbox1), button_update, FALSE, FALSE, 0);

//-------------------------------------------  
  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
                      GTK_SIGNAL_FUNC (gui_ok),
                      (void *)1);
  gtk_signal_connect (GTK_OBJECT (button_cancel), "clicked",
                      GTK_SIGNAL_FUNC (gui_ok),
                      (void *)0);

  gtk_signal_connect (GTK_OBJECT (button_update), "clicked",
                      GTK_SIGNAL_FUNC (gui_update),
                      NULL);

  gtk_signal_connect(GTK_OBJECT(drawing), "expose_event",
		       GTK_SIGNAL_FUNC(gui_draw),
		       NULL); 
  
   
   gtk_signal_connect(GTK_OBJECT(hscale3), "drag_data_received",
		       GTK_SIGNAL_FUNC(gui_update), NULL);
   gtk_signal_connect(GTK_OBJECT(hscale2), "drag_data_received",
		       GTK_SIGNAL_FUNC(gui_update), NULL);
		       
  gtk_signal_connect(GTK_OBJECT(hscale3), "drag_motion",
		       GTK_SIGNAL_FUNC(gui_update), NULL);
   gtk_signal_connect(GTK_OBJECT(hscale2), "drag_motion",
		       GTK_SIGNAL_FUNC(gui_update), NULL);		       

     gtk_signal_connect(GTK_OBJECT(hscale3), "drag_data_get",
		       GTK_SIGNAL_FUNC(gui_update), NULL);
   gtk_signal_connect(GTK_OBJECT(hscale2), "drag_data_get",
		       GTK_SIGNAL_FUNC(gui_update), NULL);	
   	
       gtk_signal_connect(GTK_OBJECT(hscale3), "drag_begin",
		       GTK_SIGNAL_FUNC(gui_update), NULL);
   gtk_signal_connect(GTK_OBJECT(hscale2), "drag_begin",
		       GTK_SIGNAL_FUNC(gui_update), NULL);	 
		       
gtk_signal_connect(GTK_OBJECT(adj_offset), "value_changed",
		       GTK_SIGNAL_FUNC(gui_update), (void *) (NULL));
gtk_signal_connect(GTK_OBJECT(adj_coeff), "value_changed",
		       GTK_SIGNAL_FUNC(gui_update), (void *) (NULL));
		            
		                      
  
  return dialog1;
}

#endif
