/***************************************************************************
                          ADM_guiResize.cpp  -  description
                             -------------------

GUI part of resize.
			     
    begin                : Thu Mar 21 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <gtk/gtk.h>
#include <time.h>
#include <sys/time.h>
#include <assert.h>

#include "fourcc.h"
#include "avio.hxx"
#include "config.h"
#include "avi_vars.h"
#ifdef HAVE_ENCODER


#include "ADM_editor/ADM_edit.hxx"
#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_video/ADM_resizebis.hxx"
// internals

static void gui_ko(GtkButton * button, gpointer user_data);
static void gui_ok(GtkButton * button, gpointer user_data);
static void gui_destroy(GtkButton * button, gpointer user_data);

static int getResizeParams(uint32_t * w, uint32_t * h, uint32_t * algo);
static GtkWidget *create_dialog1(void);

static GtkWidget *entry_w;
static GtkWidget *entry_h;
static GtkWidget *optionmenu1;
static GtkWidget *optionmenu1_menu;

static int resizelock;

extern uint8_t getRangeInMenu(GtkWidget * Menu);

typedef struct {
    uint32_t value;
    const char *name;
} COUPLE;

#define NB_ALGOS 2

COUPLE ALGOZ[NB_ALGOS] = {

    {0, "Triangle (bilinear)"},
    {1, "Mitchell (bicubic)"}
};


// AVDMVideoStreamResize *cur=NULL;

//
//
//_______________________________________
void *AVDMVideoStreamResize::configure(AVDMGenericVideoStream * instream)
{
    UNUSED_ARG(instream);
    
    RESIZE_PARAMS *par;

    _init = 0;			// force recompute
    par = _param;
    if (!getResizeParams(&par->w, &par->h, &par->algo))
      {
	  return (void *) par;
      }
      printf("\n OK was selected \n");
    // update other parameters
    _info.width = _param->w;
    _info.height = _param->h;
    // intermediate buffer
    if (_intermediate_buffer)
      {
	  delete  [] _intermediate_buffer;
	  _intermediate_buffer = NULL;
      }
    //_intermediate_buffer=(uint8_t *)malloc(3*_info.width*_in->getInfo()->height);
    _intermediate_buffer =
	new uint8_t[3 * _info.width * _in->getInfo()->height];

    return (void *) par;

}

//
//  
//
//
   static GtkWidget *resi;
int getResizeParams(uint32_t * w, uint32_t * h, uint32_t * algo)
{
    char string[50];
    gchar *str;

    int ret;
    uint32_t iw, ih, ialgo;
//  GtkWidget *br, *active;

    iw = *w;
    ih = *h;
    ialgo = *algo;
    printf("\n w h u %lu %lu", iw, ih);
    do
      {
	  resizelock = 0;
	  resi = create_dialog1();

#define SET_(x,y) 			sprintf(string, "%lu", x); \
		gtk_editable_insert_text(GTK_EDITABLE(y), string, strlen(string), &ret);
	  SET_(ih, entry_h);
	  SET_(iw, entry_w);

     gtk_option_menu_set_history (  GTK_OPTION_MENU(optionmenu1),ialgo);

	  gtk_widget_show(resi);
	  while (!resizelock)
	    {
		gtk_main_iteration();

	    }
	  // now check parameters
	  //
	  if (1 == resizelock)	//   Ok was pressed
	    {
#define GET_(x,y) str=gtk_editable_get_chars(GTK_EDITABLE(y), 0, -1); \
		      x = (uint32_t) atoi((char *)str);

					GET_(iw, entry_w);
					GET_(ih, entry_h);
					ialgo = getRangeInMenu(optionmenu1);
					// must be even
					if ((iw & 1) || (ih & 1) || (iw == 0) || (ih == 0))
		  			{
		      			
		      			if(resi)		gtk_widget_destroy(resi);
	 		         resizelock = 0;
		  			}

		
	    	}
      }
    while (!resizelock);
	if(resi)		gtk_widget_destroy(resi);
    if (resizelock == 1)
      {
	  *w = iw;
	  *h = ih;
	  *algo = ialgo;
	  return 1;
      }
    return 0;
}

//
//
//
//
void gui_ko(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    UNUSED_ARG(user_data);
    gui_ok(NULL, (gpointer) 0);
}

void gui_destroy(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    UNUSED_ARG(user_data);

 	if(resizelock) return;
	resi=NULL;
	resizelock=-1;

}

void gui_ok(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    int res;

    res = (int) user_data;
    if (resizelock)
	return;			// second call back->ignore.
    switch (res)
      {
      case 1:
	  resizelock = 1;
	  //gtk_hide_widget(wdg);

	  break;
      case 0:
	  resizelock = -1;
	  break;
      }
    return;

};



//
//

GtkWidget *create_dialog1(void)
{
    GtkWidget *dialog1;
    GtkWidget *dialog_vbox1;
    GtkWidget *vbox1;
    GtkWidget *hbox1;
    GtkWidget *vbox2;
    GtkWidget *label1;
    GtkWidget *vbox3;
    GtkWidget *label2;
    GtkWidget *hseparator1;
    GtkWidget *hbox2;
    GtkWidget *hseparator2;
    GtkWidget *glade_menuitem;

    GtkWidget *dialog_action_area1;
    GtkWidget *hbox3;
    GtkWidget *button_ok;
    GtkWidget *button3;
//   GtkWidget *button5;

    dialog1 = gtk_dialog_new();


    gtk_window_set_modal(GTK_WINDOW(dialog1), TRUE);
    //gtk_object_set_data (GTK_OBJECT (dialog1), "dialog1", dialog1);
    gtk_object_set_data_full(GTK_OBJECT(dialog1),
			     "dialog1",
			     dialog1, (GtkDestroyNotify) gui_destroy);

    gtk_window_set_title(GTK_WINDOW(dialog1), "Resize");
    gtk_window_set_policy(GTK_WINDOW(dialog1), TRUE, TRUE, FALSE);

    dialog_vbox1 = GTK_DIALOG(dialog1)->vbox;
    gtk_object_set_data(GTK_OBJECT(dialog1), "dialog_vbox1", dialog_vbox1);
    gtk_widget_show(dialog_vbox1);

    vbox1 = gtk_vbox_new(FALSE, 0);
    gtk_widget_ref(vbox1);
    gtk_object_set_data_full(GTK_OBJECT(dialog1), "vbox1", vbox1,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(vbox1);
    gtk_box_pack_start(GTK_BOX(dialog_vbox1), vbox1, TRUE, TRUE, 0);

    hbox1 = gtk_hbox_new(FALSE, 0);
    gtk_widget_ref(hbox1);
    gtk_object_set_data_full(GTK_OBJECT(dialog1), "hbox1", hbox1,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(hbox1);
    gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 0);

    vbox2 = gtk_vbox_new(FALSE, 0);
    gtk_widget_ref(vbox2);
    gtk_object_set_data_full(GTK_OBJECT(dialog1), "vbox2", vbox2,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(vbox2);
    gtk_box_pack_start(GTK_BOX(hbox1), vbox2, TRUE, TRUE, 0);

    label1 = gtk_label_new("Width");
    gtk_widget_ref(label1);
    gtk_object_set_data_full(GTK_OBJECT(dialog1), "label1", label1,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(label1);
    gtk_box_pack_start(GTK_BOX(vbox2), label1, FALSE, FALSE, 0);

    entry_w = gtk_entry_new();
    gtk_widget_ref(entry_w);
    gtk_object_set_data_full(GTK_OBJECT(dialog1), "entry_w", entry_w,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(entry_w);
    gtk_box_pack_start(GTK_BOX(vbox2), entry_w, FALSE, FALSE, 0);

    vbox3 = gtk_vbox_new(FALSE, 0);
    gtk_widget_ref(vbox3);
    gtk_object_set_data_full(GTK_OBJECT(dialog1), "vbox3", vbox3,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(vbox3);
    gtk_box_pack_start(GTK_BOX(hbox1), vbox3, TRUE, TRUE, 0);

    label2 = gtk_label_new("Height");
    gtk_widget_ref(label2);
    gtk_object_set_data_full(GTK_OBJECT(dialog1), "label2", label2,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(label2);
    gtk_box_pack_start(GTK_BOX(vbox3), label2, FALSE, FALSE, 0);

    entry_h = gtk_entry_new();
    gtk_widget_ref(entry_h);
    gtk_object_set_data_full(GTK_OBJECT(dialog1), "entry_h", entry_h,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(entry_h);
    gtk_box_pack_start(GTK_BOX(vbox3), entry_h, FALSE, FALSE, 0);

    hseparator1 = gtk_hseparator_new();
    gtk_widget_ref(hseparator1);
    gtk_object_set_data_full(GTK_OBJECT(dialog1), "hseparator1",
			     hseparator1,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(hseparator1);
    gtk_box_pack_start(GTK_BOX(vbox1), hseparator1, TRUE, TRUE, 0);



    hbox2 = gtk_hbox_new(FALSE, 0);
    gtk_widget_ref(hbox2);
    gtk_object_set_data_full(GTK_OBJECT(dialog1), "hbox2", hbox2,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(hbox2);
    gtk_box_pack_start(GTK_BOX(vbox1), hbox2, TRUE, TRUE, 0);

    hseparator2 = gtk_hseparator_new();
    gtk_widget_ref(hseparator2);
    gtk_object_set_data_full(GTK_OBJECT(dialog1), "hseparator2",
			     hseparator2,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(hseparator2);
    gtk_box_pack_start(GTK_BOX(vbox1), hseparator2, TRUE, TRUE, 0);
    //
    optionmenu1 = gtk_option_menu_new();
    gtk_widget_ref(optionmenu1);
    gtk_object_set_data_full(GTK_OBJECT(dialog1), "optionmenu1",
			     optionmenu1,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(optionmenu1);
    gtk_box_pack_start(GTK_BOX(vbox1), optionmenu1, FALSE, FALSE, 0);
    optionmenu1_menu = gtk_menu_new();

    for (uint32_t i = 0; i < NB_ALGOS; i++)
      {
	  //  combo1_items = g_list_append (combo1_items, (gpointer) ALGOZ[i].name);
	  glade_menuitem = gtk_menu_item_new_with_label(ALGOZ[i].name);
	  gtk_widget_show(glade_menuitem);
	  gtk_menu_append(GTK_MENU(optionmenu1_menu), glade_menuitem);

      }
    gtk_option_menu_set_menu(GTK_OPTION_MENU(optionmenu1),
			     optionmenu1_menu);
    gtk_widget_show(glade_menuitem);

    dialog_action_area1 = GTK_DIALOG(dialog1)->action_area;
    gtk_object_set_data(GTK_OBJECT(dialog1), "dialog_action_area1",
			dialog_action_area1);
    gtk_widget_show(dialog_action_area1);
    gtk_container_set_border_width(GTK_CONTAINER(dialog_action_area1), 10);

    hbox3 = gtk_hbox_new(FALSE, 0);
    gtk_widget_ref(hbox3);
    gtk_object_set_data_full(GTK_OBJECT(dialog1), "hbox3", hbox3,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(hbox3);
    gtk_box_pack_start(GTK_BOX(dialog_action_area1), hbox3, FALSE, FALSE,
		       0);

    button_ok = gtk_button_new_with_label("Ok");
    gtk_widget_ref(button_ok);
    gtk_object_set_data_full(GTK_OBJECT(dialog1), "button_ok", button_ok,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(button_ok);
    gtk_box_pack_start(GTK_BOX(hbox3), button_ok, FALSE, FALSE, 0);

    button3 = gtk_button_new_with_label("Cancel");
    gtk_widget_ref(button3);
    gtk_object_set_data_full(GTK_OBJECT(dialog1), "button3", button3,
			     (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show(button3);
    gtk_box_pack_start(GTK_BOX(hbox3), button3, FALSE, FALSE, 0);

    gtk_signal_connect(GTK_OBJECT(button_ok), "clicked",
		       GTK_SIGNAL_FUNC(gui_ok), (void *) 1);
    gtk_signal_connect(GTK_OBJECT(button3), "clicked",
		       GTK_SIGNAL_FUNC(gui_ko), NULL);
/*	gtk_signal_connect (GTK_OBJECT (button5), "clicked",
                      GTK_SIGNAL_FUNC (gui_submit),
                      NULL);
 */
    return dialog1;
    //////

}

#endif
