/***************************************************************************
                          ADM_guiSRT.cpp  -  description
                             -------------------
    begin                : Wed Dec 18 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <gtk/gtk.h>
#include <time.h>
#include <sys/time.h>
#include <assert.h>
#include <math.h>


#include "fourcc.h"
#include "avio.hxx"
#include "config.h"

#ifdef USE_FREETYPE

#include "avi_vars.h"
#include "ADM_toolkit/toolkit.hxx"
#include "ADM_toolkit/filesel.h"
#ifdef HAVE_ENCODER


#include "ADM_editor/ADM_edit.hxx"
#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_video/ADM_vidSRT.h"
#include "ADM_video/ADM_vidFont.h"

static  GtkWidget *labelsub;
static  GtkWidget *labelfont;
static  GtkObject *spinbutton1_adj;
static  GtkWidget *spinbutton1;

static void on_callback_ok(GtkButton * button, gpointer user_data) ;
static void on_callback_ko(GtkButton * button, gpointer user_data) ;
//static void on_callback_destroy(GtkButton * button, gpointer user_data);
static void fontCB(char *name);
static void indexSUB(char *name);
static void on_callback_sub(GtkButton * button, gpointer user_data);
static void on_callback_font(GtkButton * button, gpointer user_data);

static GtkWidget* create_dialog1 (void);
static int  GUI_subtitleParam(char *font,char *sub,int *size);
static int lock;

static char subString[300];
static char fontString[300];

void	*ADMVideoSubtitle::configure(AVDMGenericVideoStream *instream)
{
UNUSED_ARG(instream);
char c;
		 if(GUI_subtitleParam(_conf->_fontname,_conf->_subname,(int *)&_conf->_fontsize))
		 {
			 	printf("\n Font : %s", _conf->_fontname);
			 	printf("\n Sub  : %s", _conf->_subname);
			  	printf("\n Font size : %ld\n",_conf->_fontsize);

			 
		  	_fd=fopen(_conf->_subname,"rt");	
			c=fgetc(_fd);
			fseek(_fd,0,SEEK_SET);
			
			switch(c)
			{
			case '{' :
						loadSubTitle();
						break;
			case '1' :
						loadSRT();
						break;
			default:
					GUI_Alert("\n cannot identify \nsubtitle format ");						
			}					
			fclose(_fd);
			_fd=NULL;
			_bitmap=0xffffffff;
			if(!initFreeType(_conf->_fontname))
			{
				printf("\n Free type init failed for font %s!",_conf->_fontname);
			}
			else
			{
				fontSetSize(_conf->_fontsize);
			}  
			
			}
			return (void *)_conf;
}

int  GUI_subtitleParam(char *font,char *sub,int *size)
{
    static GtkWidget *wdg;
    //char *str;
    //int ret;
    
	

    while(1)
    {
       	wdg = create_dialog1();
       	lock = 0;
       	gtk_window_set_modal(GTK_WINDOW(wdg), 1);
        
        gtk_label_set_text(GTK_LABEL(labelsub),sub);
        gtk_label_set_text(GTK_LABEL(labelfont),font);
        gtk_spin_button_set_value(GTK_SPIN_BUTTON(spinbutton1),(gfloat)*size) ;
         
	    	strcpy( subString, sub);
	     strcpy( fontString, font);
	     
	     
	     	gtk_widget_show(wdg);
	     
	     	lock=0;
        runDialog(&lock);
        switch(lock)
        {
				case 1:
							    strcpy(sub,subString);
							    strcpy(font,fontString);
	    	#define CHECKSPIN(x,y) y= gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(x)) ;
          			CHECKSPIN( spinbutton1,*size);		
				#undef CHECKSPIN             				    	       
				          gtk_widget_destroy(wdg);
	                return 1;

				case -1:
		                 gtk_widget_destroy(wdg);
				case -2:
							return 0;
							break;												
	    }
     }
}
void on_callback_ok(GtkButton * button, gpointer user_data) { UNUSED_ARG(button); UNUSED_ARG(user_data); lock=1;};
void on_callback_ko(GtkButton * button, gpointer user_data) {UNUSED_ARG(button); UNUSED_ARG(user_data); lock=-1;};
//void on_callback_destroy(GtkButton * button, gpointer user_data) { UNUSED_ARG(button); UNUSED_ARG(user_data); lock=-2;};
void on_callback_sub(GtkButton * button, gpointer user_data)
{
         UNUSED_ARG(button);
	     UNUSED_ARG(user_data);
	     GUI_FileSelRead("Subtitle to load", indexSUB)  ;
}
void indexSUB(char *name)
{
	 strcpy(subString,name);
	 gtk_label_set_text(GTK_LABEL(labelsub),name);
}
void on_callback_font(GtkButton * button, gpointer user_data)
{
        UNUSED_ARG(button);
	    UNUSED_ARG(user_data);
        GUI_FileSelRead("TTF font to use", fontCB);
	
}
void fontCB(char *name)
{
 	strcpy(fontString,name);
	 gtk_label_set_text(GTK_LABEL(labelfont),name);
}
GtkWidget* create_dialog1 (void)
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *table1;
//  GtkWidget *labelsub;
//  GtkWidget *labelfont;
//  GtkObject *spinbutton1_adj;
//  GtkWidget *spinbutton1;
  GtkWidget *buttonsub;
  GtkWidget *buttonfont;

  GtkWidget *label3;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbox1;
  GtkWidget *button_ok;
  GtkWidget *button_ko;

  dialog1 = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog1", dialog1);
  gtk_window_set_title (GTK_WINDOW (dialog1), ("Subtitle"));
  gtk_window_set_policy (GTK_WINDOW (dialog1), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  table1 = gtk_table_new (3, 2, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), table1, TRUE, TRUE, 0);

  labelsub = gtk_label_new (("subtitle"));
  gtk_widget_ref (labelsub);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "labelsub", labelsub,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (labelsub);
  gtk_table_attach (GTK_TABLE (table1), labelsub, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (labelsub, 250, -2);
  gtk_misc_set_alignment (GTK_MISC (labelsub), 0, 0.5);

  labelfont = gtk_label_new (("font"));
  gtk_widget_ref (labelfont);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "labelfont", labelfont,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (labelfont);
  gtk_table_attach (GTK_TABLE (table1), labelfont, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (labelfont), 0, 0.5);

  buttonsub = gtk_button_new_with_label (("Select"));
  gtk_widget_ref (buttonsub);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "buttonsub", buttonsub,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (buttonsub);
  gtk_table_attach (GTK_TABLE (table1), buttonsub, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  buttonfont = gtk_button_new_with_label (("Select"));
  gtk_widget_ref (buttonfont);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "buttonfont", buttonfont,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (buttonfont);
  gtk_table_attach (GTK_TABLE (table1), buttonfont, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  spinbutton1_adj = gtk_adjustment_new (24, 8, 45, 1, 10, 10);
  spinbutton1 = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton1_adj), 1, 0);
  gtk_widget_ref (spinbutton1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "spinbutton1", spinbutton1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton1);
  gtk_table_attach (GTK_TABLE (table1), spinbutton1, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton1), TRUE);

  label3 = gtk_label_new (("Font size :"));
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_table_attach (GTK_TABLE (table1), label3, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label3), 0, 0.5);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbox1, TRUE, TRUE, 0);
  
  button_ok=gtk_button_new_with_label ("Ok");

  //button_ok = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (button_ok);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_ok", button_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_ok);
  gtk_box_pack_start (GTK_BOX (hbox1), button_ok, FALSE, FALSE, 0);
  GTK_WIDGET_SET_FLAGS (button_ok, GTK_CAN_DEFAULT);

  button_ko = gtk_button_new_with_label (("Cancel"));
  gtk_widget_ref (button_ko);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_ko", button_ko,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_ko);
  gtk_box_pack_start (GTK_BOX (hbox1), button_ko, FALSE, FALSE, 0);

   gtk_signal_connect(GTK_OBJECT(button_ok), "clicked",
		       GTK_SIGNAL_FUNC(on_callback_ok), (void *) 1);
     gtk_signal_connect(GTK_OBJECT(button_ko), "clicked",
		       GTK_SIGNAL_FUNC(on_callback_ko), (void *) 1);
     
     
     gtk_signal_connect(GTK_OBJECT(buttonsub), "clicked",
		       GTK_SIGNAL_FUNC(on_callback_sub), (void *) 1);
     gtk_signal_connect(GTK_OBJECT(buttonfont), "clicked",
		       GTK_SIGNAL_FUNC(on_callback_font), (void *) 1);
  
  return dialog1;
}

#endif

#endif
