/***************************************************************************
                          ADM_vidSRT.cpp  -  description
                             -------------------
    begin                : Thu Dec 12 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <assert.h>
#include <math.h>
#include "config.h"

#ifdef USE_FREETYPE

#include "fourcc.h"
#include "avio.hxx"

#include "avi_vars.h"

#include "ADM_toolkit/toolkit.hxx"
#include "ADM_editor/ADM_edit.hxx"
#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_video/ADM_vidSRT.h"
#include "ADM_video/ADM_vidFont.h"


static const char *FONTNAME="/usr/X11R6/lib/X11/fonts/truetype/arial.ttf";   

#define SUB_OUT 0xf0000000

//__________________________________________________________________

//_______________________________________________________________
 AVDMGenericVideoStream *subtitle_create(AVDMGenericVideoStream *in, void *param)

{
		return new     ADMVideoSubtitle(in,param);
}
//__________________________________________________________________

char 								*ADMVideoSubtitle::printConf(void)
 {
	  	static char buf[50];
 	
 				sprintf((char *)buf,"Subtitle (experimental)");
        return buf;
	}

//--------------------------------------------------------	
ADMVideoSubtitle::ADMVideoSubtitle(
									AVDMGenericVideoStream *in,void *setup)
{

  uint32_t frame;
  char c;
  
  _uncompressed=NULL;
  
  _in=in;		
  memcpy(&_info,_in->getInfo(),sizeof(_info));  		
	
	frame=3*_in->getInfo()->width*_in->getInfo()->height;					
	
	_subs=NULL;	
	_fd=NULL;
 	_line=0;
	_oldframe=0;
	_oldline=0;
										
	if(setup)
	{
			_conf=(SUBCONF *)setup;
		  	_fd=fopen(_conf->_subname,"rt");	
			c=fgetc(_fd);
			fseek(_fd,0,SEEK_SET);
			
			switch(c)
			{
			case '{' :
						loadSubTitle();
						break;
			case '1' :
						loadSRT();
						break;
			default:
					GUI_Alert("\n cannot identify \nsubtitle format ");						
			}					
			fclose(_fd);
			_fd=NULL;
			_bitmap=0xffffffff;
	}
	else
	{
			_conf=new SUBCONF;
			_conf->_fontsize=24;
			
			strcpy((_conf->_fontname),FONTNAME);
			_conf->_subname[0]=0;
		
	}
 
  _info.encoding=1;
  
 

	if(!initFreeType(_conf->_fontname))
	{
			printf("\n Free type init failed for font %s!",_conf->_fontname);
	}
	else
	{
		fontSetSize(_conf->_fontsize);
	}
	_bitmap=0xffffffff;
#define BITMAP_SIZE _info.width*_conf->_fontsize*5	
	_bitmapBuffer=new uint8_t[_info.width*_info.height]; 
	assert(_bitmapBuffer);
}


//                     1
//		Get in range in 121 + coeff matrix
//                     1
//
// If the value is too far away we ignore it
// else we blend
//__________________________________________________________________
uint8_t ADMVideoSubtitle::getFrameNumberNoAlloc(uint32_t frame,
						uint32_t *len,
   						uint8_t *data,
   						uint32_t *flags)
{

double f;
uint32_t time,srch;

	//		printf("\n Stabilize : %lu\n",frame);
          _uncompressed=data;
	assert(frame<_info.nb_frames);
	if(!_in->getFrameNumberNoAlloc(frame, len,data,flags)) return 0;
				    
	// if no subtitle return...
	if(!_subs) return 1;
					    
	// compute time stamp			
	      f=frame*1000000./_info.fps1000;
	      time=(uint32_t) floor(f);
	      // Do we have it already ?
	      
	      if(time<=_subs[_oldline].endTime && time >=_subs[_oldline].startTime)
	      {
	      		//printf("\n cached\n");
			blend(data); // re-use it
			return 1;	
	      
	      }
	      srch=search(time);
	      // we got the right one
	      if(srch!=SUB_OUT) // we got something...
			{
					_oldline=srch;
					//printf("\n %s \n",_subs[_oldline].string);
					displayString(_subs[_oldline].string);
					blend(data);
			}
	      
		return 1;
						
}
//__________________________________________________________________

ADMVideoSubtitle::~ADMVideoSubtitle()
{
 
//		delete [] _uncompressed;  
		if(_fd)
		{
				fclose(_fd);
				_fd=NULL;
		}
		if(_subs)
		{
				for(uint32_t i=0;i<_line;i++)
				{
						if(_subs[i].string)
							delete [] _subs[i].string;
						_subs[i].string=NULL;
				}
				delete [] _subs;
				_subs=NULL;						
		}
 	
}
//_________________________________________________________________
uint32_t	ADMVideoSubtitle::search(uint32_t time)
{
	  for(uint32_t i=0;i<_line;i++)
	  {
				if((time<=_subs[i].endTime)  &&
					(time>=_subs[i].startTime)
				)
				return i;
			
		}
		return SUB_OUT;
	  
	
}
//
//	Load subtitles in .sub format i.e. {xx}{yy} |   |
//__________________________________________________________________
uint8_t  ADMVideoSubtitle::loadSubTitle( void )
{
char string[500];
	// first cound how many line
	_line=0;
	while(fgets(string,200,_fd)) _line++;
	printf("\n subs : %ld lines\n",_line);
	// rewind
	fseek(_fd,0,SEEK_SET);
	//
	_subs=new subLine[_line];
	memset(_subs,0,sizeof(subLine)*_line);
	if(!_subs) return 0;
	// read and allocate
	double f;
	uint32_t j,k; //,l;
	
	for(uint32_t i=0;i<_line;i++)
	{
		 fgets(string,200,_fd);
		 //printf("\n in : %s ",string);
		 if(string[0]!='{') continue;
		 j=1;
		 while(string[j]!='}') j++;
		 string[j]=0;
		 f=atoi(string+1);
		 f=f*1000000./_info.fps1000;
		 _subs[i].startTime=(uint32_t)floor(f);
		 j+=2; // skip }{
	   	k=j+1;
		 while(string[k]!='}') k++;
		 string[k]=0;
		 f=atoi(string+j);
		 f=f*1000000./_info.fps1000;
		 _subs[i].endTime=(uint32_t)floor(f);
		 
		 j=strlen(string+k+1);		
		
		 _subs[i].string=new char[j+1];
		 memcpy(_subs[i].string,string+k+1,j);   
		
		 do		
		 {
			  *(_subs[i].string+j)=0; j--;
			}  while( *(_subs[i].string+j)==0xd || *(_subs[i].string+j)==0xa);	  	   
	}	
	
	return 1;
}

//
//	Load subtitles in .srt format i.e. {xx}{yy} |   |
//__________________________________________________________________
uint8_t  ADMVideoSubtitle::loadSRT( void )
{
char string[500],text[500];
uint32_t line;
	// first cound how many line
	line=0;
	_line=0;
	while(fgets(string,300,_fd)) line++;
	printf("\n subs : %ld lines\n",line);
	// rewind
	fseek(_fd,0,SEEK_SET);
	//
	_subs=new subLine[line];
	
	if(!_subs) return 0;
	memset(_subs,0,sizeof(subLine)*line);
	// read and allocate
	//double f;
	uint32_t j;
	int state=0;
	
	for(uint32_t i=0;i<line;i++)
	{
//			printf(" %d - %d\n",i,line);
		 fgets(string,200,_fd);
//		 printf(" state : %d line : %s\n",state,string);
		 switch(state)
		 {
			 	case 0: // waiting for number
			  			
			      		j=atoi(string);
			          if(j==_line+1)
			          	{
									 	state=1;
									}
								break;
				case 1: // waiting for time
								uint32_t sh,sm,ss,ms;
								uint32_t dh,dm,ds,md;
								// 00:00:00,040 --> 00:00:00,120
						
			  				if(8!=sscanf(string,"%02lu:%02lu:%02lu,%03lu --> %02lu:%02lu:%02lu,%03lu",
			        						&sh,&sm,&ss,&ms,
			              						&dh,&dm,&ds,&md))
							{
			                 			sscanf(string,"%02lu:%02lu:%02lu.%03lu --> %02lu:%02lu:%02lu.%03lu",
			        						&sh,&sm,&ss,&ms,
			              						&dh,&dm,&ds,&md);
							}
			                 
			           _subs[_line].startTime=ms+1000*(ss+sm*60+sh*3600);       
			           _subs[_line].endTime=md+1000*(ds+dm*60+dh*3600);       
			         /*  printf(" start : %d end :%d \n",
							           _subs[_line].startTime,
							           _subs[_line].endTime);
				*/								   
			           state=2;
			           text[0]=0;
			           break;
			 case 2:// looking for text
			 	       if(strlen(string)<3)
			         	{
										 _subs[_line].string=new char[strlen(text)+1];
										 memcpy(_subs[_line].string,text,strlen(text)+1);   	
										_line++;
										state=0;
										break;
								}
								else
								{
										uint32_t l=strlen(string)-1;
									
									while( string[l]==0xd || string[l]==0xa)	  	 
										 {
											 			string[l]=0;
											    	l--;
												};
									if(text[0])
												strcat(text,"|");
										strcat(text,string);									
										if(strlen(text)>300)
										{
												assert(0);
										}
								}
			 
			 					break;			 
			 
			}
		
	}	
	
	return 1;
}
//
//	Display up to 3 lines of text centered on screen
//  Each line is separated by a |
//______________________________________
void ADMVideoSubtitle::displayString(char *string)
{
	uint32_t base,last=0,line=0;
	double bbase;
	
//	printf("%s\n",string);
	
					bbase=_conf->_fontsize;
					bbase*=3.5f;
					bbase=  _info.height-bbase;
					
					if(bbase<0) bbase=0;
					base=(uint32_t)floor(bbase);
					memset(_bitmapBuffer,0,_info.height*_info.width);
					// search for | char
					for(uint32_t i=0;i<strlen(string);i++)
					{
						if( *(string+i)=='|')
							{
									displayLine(string+last,base,i-last);
									last=i+1;
									base+=_conf->_fontsize;
									line++;
									if(line>3)
									{
											printf("\n Maximum 3 lines!\n"); 
										 	return;
									}
							}						
					}
				//printf("\len :%d\n",strlen(string)-last);
				displayLine(string+last,base,strlen(string)-last);
	
}
// Display a full line centered on screen
//____________________________________________________________
void ADMVideoSubtitle::displayLine(char *string,uint32_t line, uint32_t len)
{
	//uint32_t pixstart;
	uint8_t *target;
	
	if(!len)
	{
		printf("\n null string\n");
		return;
	}
	
	uint32_t w=0;
	int ww;
	memset(_bitmapBuffer,0,5*_info.width*_conf->_fontsize);
	target=_bitmapBuffer;
	for(uint32_t i=0;i<len;i++)
	{
			if(*(string+i)==' ')
			{
					w+=_conf->_fontsize>>2;
										
			}
			else
			{
				ww=0;					
	        		if(!fontDraw((char *)(target+1+w),  *(string+i), _info.width,_conf->_fontsize,&ww)) 
				{
					printf("Font error\n");
					return;
				}
				if((ww<0)||(ww>64)) 
				{
					printf("Warning w out of bound (%d)\n",ww);
					ww=0;
				}
				w=w+ww+2;
			}
          	if(w>(_info.width-_conf->_fontsize*2)) break;
	}
	// now w is the real width to displayString
	// memcpy it to its real position
	if(w>_info.width)
		{
			printf(" line too long\n"); return;
		}
	// Get to the final positon
	target=_bitmapBuffer+line*_info.width;
	// center it
	target+=( (_info.width-w)>>1);
	uint8_t *src=_bitmapBuffer;
	
	for(uint32_t i=(3*_conf->_fontsize)>>1;i>0;i--)
	{
		for(uint32_t x=0;x<w;x++)
		{
			if( *(src+x) )  *(target+x)=*(src+x);
		}
		src+=_info.width;
		target+=_info.width;			
	}
	
	
}
//
//	Blend bitmap buffer into final screen
//      We scan the 5 last line
uint8_t ADMVideoSubtitle::blend(uint8_t *target)
{
	
	uint8_t *src=_bitmapBuffer;
	uint32_t hei,start;
	
	hei=5*_conf->_fontsize*_info.width;
	start=_info.width*(_info.height-5*_conf->_fontsize);
	
	target+=start;
	src+=start;
	
  	for(uint32_t y=0;y<hei;y++)
	{
		if(*src) *target=*src;
		*src++;
		*target++;
	
	}
	return 1;	
}
#endif
