/***************************************************************************
                          op_avisavecopy.cpp  -  description
                             -------------------
    begin                : Fri May 3 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>

#include <time.h>
#include <sys/time.h>

#include "fourcc.h"
#include "avi_vars.h"
#include "ADM_toolkit/toolkit.hxx"
#include "subchunk.h"
#include "avilist.h"

#include "ADM_audio/aviaudio.hxx"
#include "ADM_audiofilter/audioprocess.hxx"
#include "oplug_avi/op_aviwrite.hxx"
#include "oplug_avi/op_avisave.h"
#include "oplug_avi/op_savecopy.h"

uint8_t
GenericAviSaveCopy::setupVideo (char *name)
{
  //  Setup avi file output, all is coming from original avi
  // since we are inc copy mode
  memcpy(&_bih,video_body->getBIH (),sizeof(_bih));
  _bih.biSize=sizeof(_bih);  //fix old version of avidemux
  _bih.biXPelsPerMeter=_bih.biClrUsed=_bih.biYPelsPerMeter=0;
  //
  memcpy(&_videostreamheader,video_body->getVideoStreamHeader (),sizeof( _videostreamheader));
  memcpy(&_mainaviheader,video_body->getMainHeader (),sizeof(_mainaviheader));
  /* update to fix earlier bug */
   _mainaviheader.dwWidth=_bih.biWidth;
   _mainaviheader.dwHeight=_bih.biHeight;
   
   uint8_t *extraData;
   uint32_t extraLen;
   
   video_body->getExtraHeaderData(&extraLen,&extraData);
     
  if(extraLen==0)
  { 
  	if (!writter->saveBegin (name,
			   &_videostreamheader,
			   (uint8_t *)&_bih,
			   sizeof(BITMAPINFOHEADER),
			   audio_filter,
			   &_mainaviheader,
			   frameEnd - frameStart + 1))
    	{
      		GUI_Alert ("Cannot initiate save:");
      		return 0;
    	}
  }
  else
  { // extra data is present, rebuild bih field
  	uint8_t *buf;
	buf=new uint8_t[sizeof(_bih)+extraLen];
	
	
	assert(buf);
	_bih.biSize=sizeof(_bih)+extraLen;
	printf("\n using extended bih field\n");
	
	memcpy(buf,&_bih,sizeof(_bih));
	memcpy(buf+sizeof(_bih),extraData,extraLen);
	if (!writter->saveBegin (name,
			   &_videostreamheader,
			   buf,
			   sizeof(BITMAPINFOHEADER)+extraLen,
			   audio_filter,
			   &_mainaviheader,
			   frameEnd - frameStart + 1))
    	{
      		GUI_Alert ("Cannot initiate save:");
      		return 0;
    	}
	delete [] buf;
  
  
  
  }

  return 1;
}

//
//      Just to keep gcc happy....
//
GenericAviSaveCopy::~GenericAviSaveCopy ()
{

}

// copy mode
// Basically ask a video frame and send it to writter
uint8_t
GenericAviSaveCopy::writeVideoChunk (uint32_t frame)
{
  uint32_t
    len;
  uint8_t
    ret1;
  ret1 = video_body->getFrameNoAlloc (frameStart + frame, vbuffer, &len,
				      &_videoFlag);
  if (!ret1)
    return 0;
    
    // check for split
     // check for auto split
      // if so, we re-write the last I frame
      if(muxSize)
      	{
				 		// we overshot the limit and it is a key frame
				   	// start a new chunk
				  	if(handleMuxSize() && (_videoFlag & AVI_KEY_FRAME))
				   	{							   
							if(!reigniteChunk()) return 0;
						}
				 }
    
  return writter->saveVideoFrame (len, _videoFlag, vbuffer);

}
