/***************************************************************************
                          op_mpegwrite.cpp  -  description
                             -------------------

	Output plugin toward VCD
	Adapted from transcode

	I do not like it , probably will include mpeg2enc inside avidemux or ffmpeg

    begin                : Sat Aug 3 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include "config.h"

#ifdef USE_MJPEG
#include "mjpegtools/yuv4mpeg.h"
#include "mjpegtools/mpegconsts.h"

#include "fourcc.h"
#include "avi_vars.h"
#include "ADM_toolkit/toolkit.hxx"
#include "subchunk.h"


//#include "aviaudio.hxx"
#include "ADM_audiofilter/audioprocess.hxx"

#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_gui/GUI_encoder.h"
#include "ADM_filter/video_filters.h"


#include "oplug_mpeg/op_mpeg_support.h"
#include "oplug_mpeg/op_mpeg_write.h"
#include "prefs.h"

// ______________________________________________
// 								Initialise all variables
// ______________________________________________

mpegWritter::mpegWritter( void )
{
    							_mpipe=NULL;
							_w=_h=0;
							_fps1000=0;
							  _incoming=NULL;;
							_page=0;
                          				_buffer=_swapbuffer=NULL;
							format=0;
							bitrate=0;
							quantisation=0;
							mpeg2enc_extra_param=NULL;
}
mpegWritter::~mpegWritter(  )
{
    							end();
}

// ______________________________________________
//   set some params for mpeg2enc
// ______________________________________________

void mpegWritter::set_bitrate(uint16_t br){
   if( br > 0 )
      bitrate = br;
}

void mpegWritter::set_quantisation(uint8_t qs){
   if( qs > 1 && qs < 32 )
      quantisation = qs;
}

void mpegWritter::set_mpeg2enc_extra_param(const char * str){
   if( str && strlen(str) ){
      if( mpeg2enc_extra_param )
      {
        // delete [] mpeg2enc_extra_param;
	free (mpeg2enc_extra_param);
	mpeg2enc_extra_param=NULL;
	}
      mpeg2enc_extra_param = strdup( str );
   }
}

// ______________________________________________
// 										Do the actual save
// ______________________________________________

uint8_t  mpegWritter::save_vcd(char *name){
   format = 1;
   bitrate = quantisation = 0;
   return( mpegWritter::save(name) );
}
uint8_t  mpegWritter::save_svcd(char *name){
   format = 4;
   if( bitrate == 0 )
	prefs->get(CODECS_MPEG2ENC_SVCD_MAXBITRATE,   &bitrate);
   if( quantisation == 0 )
	prefs->get(CODECS_MPEG2ENC_SVCD_QUANTISATION, &quantisation);
   // save values to global prefs for next call
   prefs->set(CODECS_MPEG2ENC_SVCD_MAXBITRATE,   bitrate);
   prefs->set(CODECS_MPEG2ENC_SVCD_QUANTISATION, quantisation);
   prefs->set(CODECS_MPEG2ENC_SVCD_EXTRAPARAMS, mpeg2enc_extra_param);
   // load my range conform values or the defaults
   prefs->get(CODECS_MPEG2ENC_SVCD_MAXBITRATE,   &bitrate);
   prefs->get(CODECS_MPEG2ENC_SVCD_QUANTISATION, &quantisation);
   return( mpegWritter::save(name) );
}
uint8_t  mpegWritter::save_dvd(char *name){
   format = 8;
   if( bitrate == 0 )
	prefs->get(CODECS_MPEG2ENC_DVD_MAXBITRATE,   &bitrate);
   if( quantisation == 0 ) 
	prefs->get(CODECS_MPEG2ENC_DVD_QUANTISATION, &quantisation);
   // save values to global prefs for next call
   prefs->set(CODECS_MPEG2ENC_DVD_MAXBITRATE,   bitrate);
   prefs->set(CODECS_MPEG2ENC_DVD_QUANTISATION, quantisation);
   prefs->set(CODECS_MPEG2ENC_DVD_EXTRAPARAMS, mpeg2enc_extra_param);
#warning FIXME
prefs->save();
   // load my range conform values or the prefs again
   prefs->get(CODECS_MPEG2ENC_DVD_MAXBITRATE,   &bitrate);
   prefs->get(CODECS_MPEG2ENC_DVD_QUANTISATION, &quantisation);
   return( mpegWritter::save(name) );
}

uint8_t  mpegWritter::save(char *name)
{	
uint32_t total;

   	_incoming = getLastVideoFilter ();	
	_w=_incoming->getInfo()->width;
	_h=_incoming->getInfo()->height;
	_fps1000=_incoming->getInfo()->fps1000;

 	_page=_w*_h;
	_page+=_page>>1;

			if(!init(name)) return 0;
			printf("\n mpeg2enc init done \n");


	_buffer=new uint8_t[_w*_h*2];
	_swapbuffer=new uint8_t[_w*_h>>2];

	assert(  _buffer);
	assert(  _swapbuffer);

  GUI_Working ();

	total=frameEnd-frameStart;
	if(!total) return 0;

  GUI_UpdateWorking (0, total);

		for(uint32_t i=0;i<=total;i++)
			{
            	if(!encode(i+frameStart))
					{
                   	GUI_Alert("Encoding error !");
						GUI_StopWorking();
						end();
						return 0 ;
					}
				//	printf("\n pipe opened %ld\n",i);
					if(GUI_UpdateWorking (i,total))
						{
									GUI_StopWorking();
									 end();
									 return 0;
						}
			}
			GUI_StopWorking();
			 end();
			return 1;
}


// ______________________________________________
//	Construct mpeg2enc string parameter
// ______________________________________________

uint8_t mpegWritter::init(char *name)
{
 char string[1024];
 static y4m_stream_info_t y4mstream;
 int frate=0;
          // a : 4/3 --format VCD -F frame rate
			
#define IFX(x,y) if( (_fps1000-x)*(_fps1000-x) < 500) frate=y;

			IFX(23976,1);
			IFX(24000,2);
			IFX(25000,3);
			IFX(29970,4);

			if(frate==0)
				{
               	GUI_Alert("Frame rate incompatible !");
					return 0;
				}

         snprintf(string,1024,"mpeg2enc -o %s  -f %d -F %d -a 2 -v 0",name,format,frate);
         string[1023] = '\0';
         if( bitrate > 0 )
            snprintf(&string[strlen(string)],1024-strlen(string)," -b %d", bitrate);
         string[1023] = '\0';
         if( quantisation > 0 )
            snprintf(&string[strlen(string)],1024-strlen(string)," -q %d", quantisation);
         string[1023] = '\0';
         if( mpeg2enc_extra_param )
            snprintf(&string[strlen(string)],1024-strlen(string)," %s", mpeg2enc_extra_param);
         string[1023] = '\0';
			printf("\n %s \n",string);
			_mpipe=popen(string,"w");

			printf("\n pipe opened\n");

			if(!_mpipe) return 0;
			// now set up y4m stuff ...
			 y4m_init_stream_info(&y4mstream);
   		//	 y4m_si_set_framerate(&y4mstream,(_y4m_ratio)25);
      y4m_ratio_t *ratio=&(y4mstream.framerate);
      ratio->n=_fps1000;
      ratio->d=1000;
      printf("\n Fps %ld\n",_fps1000);
     
    		//y4m_si_set_interlace(&y4mstream,Y4M_UNKNOWN );
    		y4m_si_set_sampleaspect(&y4mstream,y4m_sar_SQUARE); //y4m_sar_UNKNOWN);

		    y4mstream.height = _h;
		    y4mstream.width = _w;

	printf("\n init header....\n");


		      if( !y4m_write_stream_header2( _mpipe, &y4mstream )  )
				{
       		 	printf(" Y4M init failed !\n");
					return 0;
					}
	printf("done\n");

		return 1;			
}

// ______________________________________________
//						Clean -up
// ______________________________________________
uint8_t mpegWritter::end( void )
{
    	if(_mpipe) pclose(_mpipe);
	if(_buffer) delete [] _buffer;
	if(_swapbuffer) delete [] _swapbuffer;
	if(mpeg2enc_extra_param) 
	{
	//	delete [] mpeg2enc_extra_param;
		free(mpeg2enc_extra_param);
		mpeg2enc_extra_param=NULL;
	}

		_mpipe=NULL;
       		_buffer=NULL;
		_swapbuffer=NULL;
		mpeg2enc_extra_param=NULL;

      return 1;
}	


// ______________________________________________
//							Encode one frame
// ______________________________________________
uint8_t mpegWritter::encode( uint32_t framenum)
{
   y4m_frame_info_t info;

	uint32_t size,flags;

      y4m_init_frame_info(&info);

      if( !y4m_write_frame_header2( _mpipe, &info )  )
			{
				printf("\n cannot write into mpipe !\n");;
				return 0;
	      }

			if(!	_incoming->getFrameNumberNoAlloc(		framenum, &size,(uint8_t *) _buffer,&flags))
				{
               	printf("\n Get Frame error !\n");
					return 0;
				}

		// Swap u & v
		memcpy(  _swapbuffer,_buffer + _w*_h,  (_w*_h)>>2);
		memcpy(  _buffer + _w*_h,_buffer + _w*_h+((_w*_h)>>2),  (_w*_h)>>2);
		memcpy(  _buffer + _w*_h+((_w*_h)>>2),  _swapbuffer,(_w*_h)>>2);

      fwrite(_buffer, _page, 1, _mpipe);

	//	printf("\n lu : %lu \n",framenum);

	return 1;
}

#endif
