/***************************************************************************
                          oplug_vcdff.cpp  -  description
                             -------------------
    begin                : Sun Nov 10 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
    
    Ouput using FFmpeg mpeg1 encoder
    Much faster than mjpegtools, albeit quality seems inferior
    
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include <math.h>
#include "config.h"

#ifdef USE_FFMPEG
extern "C" {
#include "ADM_lavcodec.h"
};
#include "avi_vars.h"
#include "prototype.h"


#include "ADM_colorspace/colorspace.h"
#include "ADM_toolkit/toolkit.hxx"

#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_gui/GUI_encoder.h"
#include "ADM_filter/video_filters.h"


#include "ADM_encoder/ADM_vidEncode.hxx"

#include "ADM_encoder/adm_encoder.h"
#include "ADM_codecs/ADM_divxEncode.h"
//#include "ADM_encoder/adm_encdivx.h"

#include "ADM_codecs/ADM_ffmpeg.h"
#include "ADM_encoder/adm_encffmpeg.h"
#include "oplug_mpegFF/oplug_vcdff.h"

static uint8_t *_buffer=NULL,*_outbuffer=NULL;
static void  end (void);

extern FFMPEGConfig ffmpegMpeg1Config;
//static FFMPEGConfig ffmpegConfigforXVCD;


extern int getXvcdCompressParams(COMPRESSION_MODE * mode, uint32_t * qz,
		      uint32_t * br,uint32_t *fsize,FFcodecSetting *conf);


void oplug_mpegff(char *name)
{
AVDMGenericVideoStream *_incoming;
EncoderFFMPEG *encoder;
FILE *file;

uint32_t _w,_h,_fps1000,_page,total;	

uint32_t len,flags;
uint32_t size;
	
		
	_incoming = getLastVideoFilter ();	
	_w=_incoming->getInfo()->width;
	_h=_incoming->getInfo()->height;
	_fps1000=_incoming->getInfo()->fps1000;
 	_page=_w*_h;
	_page+=_page>>1;


	
	total=frameEnd-frameStart;
	if(!total) return ;	
// ________alternate config____________
	
	
	if(!getXvcdCompressParams(&ffmpegMpeg1Config.generic.mode,
			&ffmpegMpeg1Config.generic.qz,
			&ffmpegMpeg1Config.generic.bitrate,
			&ffmpegMpeg1Config.generic.finalsize,
			&ffmpegMpeg1Config.specific))
		return ;
// override with mpeg1 specific stuff


		
//__________________________________					
	file=fopen(name,"wb");
	if(!file)
	{
		GUI_Alert("Cannot open output file !");	 
	 return ;
	}
					
  encoder= new EncoderFFMPEG(FF_MPEG1,&ffmpegMpeg1Config);
  encoder->setLogFile("/tmp/mpegVBR.txt",1);  
  if(!encoder->configure(_incoming))
  {
		delete encoder;
		return;			
	}

  	
	_buffer=new uint8_t[_page];
	_outbuffer=new uint8_t[_page];

	assert(  _buffer);	
	assert(  _outbuffer);
	
  GUI_encoderStart();
  GUI_encoderSetCodec("FFmpeg Mpeg1 VBR");


 

  		// pass 1
    	if(encoder->isDualPass())
     	{
				GUI_encoderSetPhasis ("Pass 1/2");				
			encoder->startPass1();		
			for(uint32_t i=0;i<=total;i++)
			{
				GUI_encoderSetFrame(i,total);
				if(!encoder->encode( frameStart+i, &len,(uint8_t *) _buffer,&flags))
				{
					GUI_Alert(" Error in pass 1!");	
				}
			
			}
			encoder->startPass2();

		}
		if(encoder->isDualPass())     	
     GUI_encoderSetPhasis ("Pass 2/2");			
    else 
     GUI_encoderSetPhasis ("Encoding");			

		for(uint32_t i=0;i<=total;i++)
			{
				
       	// get frame
				if(!encoder->encode( frameStart+i, &len,(uint8_t *) _outbuffer,&flags))
				{
					GUI_Alert("Error in pass 2");
					goto finish;
				}
				
				fwrite(_outbuffer,len,1,file);
				size=ftell(file);
				size=size/(1024*1024);	
				GUI_encoderSetSize((int)size);
				GUI_encoderSetFrame(i,total);       
					if(!GUI_encoderIsAlive ())
						{
									 goto finish;
									 return ;
						}
			}
finish:			
			GUI_encoderStop();
		 	end();
			fclose(file);
			delete encoder;
			return ;
}
	
void end (void)
{
	
	delete [] _buffer;
	delete [] _outbuffer;

	_buffer		=NULL;
	_outbuffer=NULL;
	
	}	
	
#endif	
// EOF
